#!/bin/bash
# ============================================================================
# 
# Nagios Configuration
#
# ----------------------------------------------------------------------------
#
# TODO:
#
# ============================================================================
#
. ./utils.sh

# ----------------
# Global Variables:
# ----------------
. ./params.sh

CheckRoot

if [ "$UPDATE" = "y" ]; then
	exit 0
fi

# --------------------
# Nagios Configuration:
# --------------------

echo "Nagios post-configuration..." | tee -a "$OUTPUTFILE"

# Change the value of urlpath in cgi.cfg:
NEWVAL=`echo $HTMLURL | sed -e 's/\//\\\\\//g'`
sed -i -e "s/^url_html_path=.*/url_html_path=$NEWVAL/" "$DSTDIR/etc/cgi.cfg" 2>>"$OUTPUTFILE"

# Change the value of use_authentication. The interface is protected
# by the htpasswd file
#sed -i -e 's/^use_authentication=1/use_authentication=0/' "$DSTDIR/etc/cgi.cfg" 2>>"$OUTPUTFILE"

# Accept external commands:
sed -i -e 's/^check_external_commands=0/check_external_commands=1/' "$DSTDIR/etc/nagios.cfg" 2>>"$OUTPUTFILE"
chgrp $APACHEGRP "$DSTDIR/var/rw"

# Allow use of CGI to manage Nagios:
sed -i -e 's/^use_authentication=.*$/use_authentication=1/' \
	-e "s/^authorized_for_system_information=.*/authorized_for_system_information=$WEBUSER/" \
	-e "s/^authorized_for_configuration_information=.*/authorized_for_configuration_information=$WEBUSER/" \
	-e "s/^authorized_for_system_commands=.*/authorized_for_system_commands=$WEBUSER/" \
	-e "s/^authorized_for_all_services=.*/authorized_for_all_services=$WEBUSER/" \
	-e "s/^authorized_for_all_hosts=.*/authorized_for_all_hosts=$WEBUSER/" \
	-e "s/^authorized_for_all_service_commands=.*/authorized_for_all_service_commands=$WEBUSER/" \
	-e "s/^authorized_for_all_host_commands=.*/authorized_for_all_host_commands=$WEBUSER/" \
	"$DSTDIR/etc/cgi.cfg" 2>>"$OUTPUTFILE"

# ---------------------------------------------------
# Added with v0.8: Install and configure nagiosmap.pl
# ---------------------------------------------------
cp distrib/nagiosmap.pl $DSTDIR/bin/
chmod +x $DSTDIR/bin/nagiosmap.pl
NEWVAL=`echo $DSTDIR/share/images/logos | sed -e 's/\//\\\\\//g'`
sed -i -e "s/\$imgpath=\"(.*)\"/\$imgpath=\"$NEWVAL\"/" $DSTDIR/bin/nagiosmap.pl

# ---------------------------------------------------------
# Added with v1.1.0: Install and configure nagxmlstatus.cgi:
# ---------------------------------------------------------
cp distrib/browser/nagxmlstatus.cgi $DSTDIR/sbin/
chown $NAGIOSUSR:$NAGIOSGRP $DSTDIR/sbin/nagxmlstatus.cgi
chmod +x $DSTDIR/sbin/nagxmlstatus.cgi
NEWVAL=`echo $DSTDIR/var/status.dat | sed -e 's/\//\\\\\//g'`
sed -i -e "s/^my \$STATUSFILE.*/my \$STATUSFILE = \"$NEWVAL\";/" "$DSTDIR/sbin/nagxmlstatus.cgi" 2>>"$OUTPUTFILE"

exit 0

# EOF
