#!/bin/bash
# ============================================================================
# 
# Installation and configuration of the server part for DNX
#
# ----------------------------------------------------------------------------
#
# TODO: 
#
# ============================================================================
#
. ./utils.sh

# ----------------
# Global Variables:
# ----------------
. ./params.sh

CheckRoot

if [ "$UPDATE" = "y" ]; then
	exit 0
fi

if [ "$WITHDNX" = "0" ]; then
	Info "You did not wish to install DNX !"
	exit 0
fi

# ------------------------------------------------
# Extract the sources in the destination directory:
# ------------------------------------------------
echo "Extracting DNX sources" | tee -a "$OUTPUTFILE"
tar xvz -C "$TMPDIR" -f distrib/dnx-$DNXVERS.tar.gz >> "$OUTPUTFILE" 2>&1
ln -s dnx-$DNXVERS "$TMPDIR/dnx"

# -------------------------
# Compile and install
# -------------------------
if [ ! -d "$DSTDIR/dnx" ]; then
	mkdir "$DSTDIR/dnx"
fi

pushd tmp/dnx >/dev/null
./configure --prefix="$DSTDIR/dnx" --with-nagios3x \
            --with-nagios-user=$NAGIOSUSR --with-nagios-group=$NAGIOSGRP \
	    --with-dnx-user=$NAGIOSUSR --with-dnx-group=$NAGIOSGRP >> "$OUTPUTFILE" 2>&1
make >> "$OUTPUTFILE" 2>&1
mkdir "$DSTDIR/dnx/bin" 2>/dev/null
make install-server install-servercfg >> "$OUTPUTFILE" 2>&1
cp stats/dnxstats "$DSTDIR/dnx/bin/"
popd >/dev/null

exit 0

# EOF
