#!/bin/bash
# ============================================================================
# 
# Last commands
#
# ----------------------------------------------------------------------------
#
# TODO:
#
# ============================================================================
#
. ./utils.sh

# ----------------
# Global Variables:
# ----------------
. ./params.sh

CheckRoot

if [ "$UPDATE" = "y" ]; then
	exit 0
fi

# --------------
# Start ndoutils:
# --------------
if [ "$WITHNDO" != "0" ]; then
	# TODO: write a "nice" service script ?

	# Added from v1.0.3: do not add this line twice:
	CMD="su $NAGIOSUSR -c \"$DSTDIR/bin/ndo2db-3x -c $DSTDIR/etc/ndo2db.cfg\""
	if ! grep "$CMD" /etc/rc.local >/dev/null 2>&1; then
		# under Ubuntu, the ending line is "exit 0"
		if grep "^exit 0" /etc/rc.local >/dev/null 2>&1; then
			sed -i -e "/^exit 0/i\\
$CMD" /etc/rc.local
		else
			echo $CMD >> /etc/rc.local
		fi
	fi

	# restart nagios if needed, check ndomod.o loaded in log file
	#killall -HUP nagios
fi

# ------------
# Start nagios:
# ------------
# Added since v0.9:
AskYesNo "Do you want to start nagios at boot time ?"
if [ "$REP" = "y" ]; then
	# RedHat or Debian like distro ?
	if type chkconfig >/dev/null 2>&1; then
		chkconfig --add nagios
	fi
	if type update-rc.d >/dev/null 2>&1; then
		update-rc.d nagios start 99 2 3 4 5 . stop 01 0 1 6 .
	fi
fi

AskYesNo "Do you want to start nagios now ?"
if [ "$REP" = "y" ]; then
	if [ "$WITHNDO" != "0" ]; then
		su $NAGIOSUSR -c "$DSTDIR/bin/ndo2db-3x -c $DSTDIR/etc/ndo2db.cfg"
	fi
	/etc/rc.d/init.d/nagios start 2>/dev/null || /etc/init.d/nagios start 2>/dev/null
fi

# EOF
