#!/bin/bash
# ============================================================================
# 
# Installation and configuration of Nagtrap
#
# ----------------------------------------------------------------------------
#
# TODO: 
#
# ============================================================================
#
. ./utils.sh

# ----------------
# Global Variables:
# ----------------
. ./params.sh

CheckRoot

if [ "$UPDATE" = "y" ]; then
	exit 0
fi

if [ "$WITHNAGTRAP" = "0" ]; then
	Info "You did not wish to install Nagtrap!"
	exit 0
fi

# ------------------------------------------------
# Extract the sources in the destination directory:
# ------------------------------------------------
echo "Extracting Nagtrap sources" | tee -a "$OUTPUTFILE"
tar xvz -C "$TMPDIR" -f distrib/nagtrap-$NAGTRAPVERS.tar.gz >> "$OUTPUTFILE" 2>&1
ln -s nagtrap-$NAGTRAPVERS "$TMPDIR/nagtrap"

# -------------------
# Create the Database:
# -------------------
echo "Installation..."
pushd tmp/nagtrap >/dev/null 
if [ "$DBADMINPWD" = "" ]; then
	mysql -u "$DBADMIN" -h "$DBSRV" "$DBNAME" < db/snmptt-1.2.sql
	mysql -u "$DBADMIN" -h "$DBSRV" "$DBNAME" < db/snmptt_unknown.sql
else
	mysql -u "$DBADMIN" -p$DBADMINPWD -h "$DBSRV" "$DBNAME" < db/snmptt-1.2.sql
	mysql -u "$DBADMIN" -p$DBADMINPWD -h "$DBSRV" "$DBNAME" < db/snmptt_unknown.sql
fi

# ---------------------------
# Configure the Web Interface:
# ---------------------------
mv nagtrap $DSTDIR/share/
chown -R $NAGIOSUSR:$APACHEGRP $DSTDIR/share/nagtrap/
mv $DSTDIR/share/nagtrap/etc/config.ini.php-dist $DSTDIR/share/nagtrap/etc/config.ini.php

sed -i -e "s/^host.*=.*/host = $DBSRV/" \
       -e "s/^user.*=.*/user = $DBUSER/" \
       -e "s/^password.*=.*/password = $DBPWD/" \
       -e "s/^name.*=.*/name = $DBNAME/" \
       -e "s/^allowedUser.*=.*/allowedUser = $WEBUSER/" \
       $DSTDIR/share/nagtrap/etc/config.ini.php

# Add an Administration option in nagios menu:
sed -i -e "163a\\
<tr><td width=13><img src=\"images/greendot.gif\" width=\"13\" height=\"14\" name=\"docs-dot\"></td><td nowrap><a href=\"/nagios/nagtrap/\" target=\"main\" onMouseOver=\"switchdot('docs-dot',1)\" onMouseOut=\"switchdot('docs-dot',0)\" class=\"NavBarItem\">NagTrap</a></td></tr>" \
$DSTDIR/share/side.html

# -----------------------
# Copy the nagios plugin:
# -----------------------
cp plugin/check_snmptraps.pl $DSTDIR/libexec/

sed -i -e "s/^my \$dbHost.*/my \$dbHost = \"$DBSRV\";/" \
       -e "s/^my \$dbName.*/my \$dbName = \"$DBNAME\";/" \
       -e "s/^my \$dbUser.*/my \$dbUser = \"$DBUSER\";/" \
       -e "s/^my \$dbPass.*/my \$dbPass = \"$DBPWD\";/" \
       $DSTDIR/libexec/check_snmptraps.pl

popd >/dev/null

exit 0

# EOF
