#!/bin/bash
# ============================================================================
# 
# Installation script for nmap
#
# ----------------------------------------------------------------------------
#
# Since v0.7, nmap is compiled without nmapfe
#
# ============================================================================
#
. ./utils.sh

# ----------------
# Global Variables:
# ----------------
. ./params.sh

if [ "$UPDATE" = "y" ]; then
	exit 0
fi

# ------------------------------------------------
# Extract the sources in the destination directory:
# ------------------------------------------------
if [ "$WITHNMAP" = "0" ]; then
	Info "You did not wish to install nmap or it is already installed"
	exit 0
fi

echo "nmap Installation" | tee -a "$OUTPUTFILE"

tar xvj -C "$TMPDIR" -f distrib/nmap-$NMAPVERS.tar.bz2 >>"$OUTPUTFILE" 2>&1
ln -s nmap-$NMAPVERS "$TMPDIR/nmap"

export BUILD_DIR=`pwd`/tmp/nmap

# -------------------
# nmap Compilation:
# -------------------
pushd $BUILD_DIR >>"$OUTPUTFILE" 2>&1

# added from v0.7.2: it seems ./configure failed on SuSE
# since it cannot create a tmp subdir at this step !?
mkdir tmp
mkdir nbase/tmp
mkdir nsock/src/tmp
mkdir libpcap/tmp
mkdir libpcre/tmp
mkdir nmapfe/tmp
mkdir libdnet-stripped/tmp

echo "nmap Compilation..." | tee -a "$OUTPUTFILE"
export INSTALL_DIR=$DSTDIR/nmap
./configure --without-nmapfe --prefix=$INSTALL_DIR >>"$OUTPUTFILE" 2>&1
make >>"$OUTPUTFILE" 2>&1
make install >>"$OUTPUTFILE" 2>&1

popd >>"$OUTPUTFILE" 2>&1

exit 0

# EOF
