<?php
include_once "nagiosobject.class.php";

class Contact extends NagiosObject
{
public function __construct()
{
	parent::__construct();
	$this->m_attrdef2 = Contact::$m_attrdef;
	$this->m_objtype  = "Contact";
	$this->m_objidref =& Contact::$m_objid;
	$this->m_refby2   =& Contact::$m_refby;
	//$this->m_groups   =& Contact::$m_groupmand;
	$this->m_implied2 =& Contact::$m_impliedInheritance;
	$this->m_hasDetails = true;
}

static private $m_objid = 0;

static private $m_attrdef = array (

	"contact_name"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_MANDINDEX,
	),
	"__cfgfile" 	=> array ( 
		"type" 	=> OA::CFGFILE_T,
		"flag" 	=> OA::NOT_DUMPMAND,
	),
	"name"		=> array ( 
		"type"	=> OA::SYMBOL_T, 
		"flag"	=> OA::DONT_INHERIT,
	),
	"register"		=> array ( 
		"type"	=> OA::BOOL_T,
		"flag"	=> OA::DONT_INHERIT,
		"default"	=> "yes",
	),
	"use"		=> array ( 
		"type" 	=> OA::CONTACTTEMPL_T 
	),
	"alias"		=> array (
		"type"	=> OA::COMMENT_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"contactgroups"	=> array (
		"type"	=> OA::CONTACTGRPLIST_T,
		"flag"	=> 0,
	),
	# New from nagios 3.0:
	"host_notifications_enabled"	=> array (
		"type"	=> OA::BOOL_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	# New from nagios 3.0:
	"service_notifications_enabled"	=> array (
		"type"	=> OA::BOOL_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"host_notification_period"	=> array (
		"type"	=> OA::TIMEPERIOD_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"service_notification_period"	=> array (
		"type"	=> OA::TIMEPERIOD_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"host_notification_options"	=> array (
		"type"	=> OA::HOSTNOTIFOPT_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"service_notification_options"	=> array (
		"type"	=> OA::SRVNOTIFOPT_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"host_notification_commands"	=> array (
		"type"	=> OA::COMMANDLIST_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"service_notification_commands"	=> array (
		"type"	=> OA::COMMANDLIST_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"email"		=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
	),
	"pager"		=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
	),
	"address1"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
	),
	"address2"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
		"detail"	=> true,
	),
	"address3"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
		"detail"	=> true,
	),
	"address4"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
		"detail"	=> true,
	),
	"address5"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
		"detail"	=> true,
	),
	"address6"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
		"detail"	=> true,
	),
	# New from nagios 3.0:
	"can_submit_commands"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	# New from nagios 3.0:
	"retain_status_information"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	# New from nagios 3.0:
	"retain_nonstatus_information"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
);

static private $m_refby = array (
	"Host"			=> array ( "contacts" ), # from nagios v3.0
	"Service"		=> array ( "contacts" ), # from nagios v3.0
	"HostEscalation"	=> array ( "contacts" ), # from nagios v3.0
	"ServiceEscalation"	=> array ( "contacts" ), # from nagios v3.0
	"ContactGroup"		=> array ( "members", ),
);

# from eznag v0.11: groups of attributes are handled ina different way:
# SEMIMAND attribute + # mandgrp
/*
static private $m_groupmand = array (
	"address" => array ( "email", "pager", "address1", "address2", 
			     "address3", "address4", "address5", "address6" ),
);
*/

static private $m_impliedInheritance = array (
);

};
?>
