<?php
include_once "nagiosobject.class.php";

class Host extends NagiosObject
{
public function __construct()
{
	parent::__construct();
	$this->m_attrdef2 = Host::$m_attrdef;
	$this->m_objtype  = "Host";
	$this->m_objidref =& Host::$m_objid;
	$this->m_refby2   =& Host::$m_refby;
	$this->m_implied2 =& Host::$m_impliedInheritance;
	$this->m_hasDetails = true;
}

static private $m_objid = 0;

static private $m_attrdef = array (

	"host_name"		=> array ( 
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_MANDINDEX,
	),
	"__cfgfile" 	=> array ( 
		"type" 	=> OA::CFGFILE_T,
		"flag" 	=> OA::NOT_DUMPMAND,
	),
	"name"		=> array ( 
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::DONT_INHERIT,
	),
	"register"		=> array ( 
		"type"	=> OA::BOOL_T,
		"flag"	=> OA::DONT_INHERIT,
		"default"	=> "yes",
		"detail"	=> true,
	),
	"use"		=> array ( 
		"type" 	=> OA::HOSTTEMPL_T 
	),
	# new from Nagios v3.0
	"display_name"	=> array (
		"type"	=> OA::SYMBOL_T,
	),
	"alias"			=> array ( 
		"type"	=> OA::COMMENT_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"address"		=> array ( 
		"type" 	=> OA::IPADDR_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"parents"		=> array ( 
		"type"	=> OA::HOSTLIST_T 
	),
	"hostgroups"		=> array ( 
		"type"	=> OA::HOSTGRPLIST_T 
	),
	"check_command"		=> array ( 
		"type"	=> OA::COMMAND_T 
	),
	# new from Nagios v3.0
	"initial_state"		=> array (
		"type"	=> OA::HOSTSTALKOPT_T,
		"detail"	=> true,
	),
	"max_check_attempts"	=> array ( 
		"type"	=> OA::NUMERIC_T,
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
	),
	"check_interval"	=> array (
		"type"	=> OA::NUMERIC_T,
		"detail"	=> true,
		"unit" 	=> "minutes",
	),
	# new from Nagios v3.0
	"retry_interval"	=> array (
		"type"	=> OA::NUMERIC_T,
		"detail"	=> true,
		"unit" 	=> "minutes",
	),
	"active_checks_enabled"	=> array (
		"type"	=> OA::BOOL_T,
	),
	"passive_checks_enabled"	=> array (
		"type" 	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"check_period"		=> array (
		"type"	=> OA::TIMEPERIOD_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	"obsess_over_host"	=> array (
		"type" 	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"check_freshness"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"freshness_threshold"	=> array (
		"type"	=> OA::NUMERIC_T,
		"detail"	=> true,
		"unit"	=> "seconds",
	),
	"event_handler"		=> array ( 
		"type"	=> OA::COMMAND_T ,
		"detail"	=> true,
	),
	"event_handler_enabled"	=> array ( 
		"type"	=> OA::BOOL_T, 
		"detail"	=> true,
	),
	"low_flap_threshold"	=> array ( 
		"type"	=> OA::PERCENT_T,
		"detail"	=> true,
	),
	"high_flap_threshold"	=> array ( 
		"type"	=> OA::PERCENT_T, 
		"detail"	=> true,
	),
	"flap_detection_enabled"	=> array ( 
		"type"	=> OA::BOOL_T, 
		"detail"	=> true,
	),
	# new from Nagios v3.0
	"flap_detection_options"	=> array ( 
		"type"	=> OA::HOSTSTALKOPT_T,
		"detail"	=> true,
	),
	"process_perf_data"	=> array ( 
		"type"	=> OA::BOOL_T,
		"dflt"	=> 0,
		"detail"	=> true,
	),
	"retain_status_information"	=> array ( 
		"type"	=> OA::BOOL_T,
		"dflt"	=> 0,
		"detail"	=> true,
	),
	"retain_nonstatus_information"	=> array ( 
		"type"	=> OA::BOOL_T,
		"dflt"	=> 0,
		"detail"	=> true,
	),
	# new from Nagios v3.0
	"contacts"	=> array (
		"type"	=> OA::CONTACTLIST_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
	),
	"contact_groups"	=> array (
		"type"	=> OA::CONTACTGRPLIST_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mandgrp" => 1,
	),
	"notification_interval"	=> array ( 
		"type"	=> OA::NUMERIC_T, 
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
		"unit"	=> "minutes",
	),
	# new from Nagios v3.0
	"first_notification_delay"	=> array (
		"type"	=> OA::NUMERIC_T,
		"detail"	=> true,
		"unit" 	=> "minutes",
	),
	"notification_period"	=> array ( 
		"type"	=> OA::TIMEPERIOD_T, 
		"flag"	=> OA::IS_MANDATORY,
	),
	"notification_options"	=> array ( 
		"type"	=> OA::HOSTNOTIFOPT_T,
		"detail"	=> true,
	),
	"notifications_enabled"	=> array ( 
		"type"	=> OA::BOOL_T
	),
	"stalking_options"	=> array ( 
		"type"	=> OA::HOSTSTALKOPT_T,
		"detail"	=> true,
	),
	# All the following are new from Nagios v3.0
	"notes"		=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"notes_url"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"action_url"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"icon_image"	=> array (
		"type"	=> OA::IMAGE_T,
		"detail"	=> true,
	),
	"icon_image_alt"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"vrml_image"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"statusmap_image"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"2d_coords"	=> array (
		"type"	=> OA::COORD2D_T,
		"detail"	=> true,
	),
	"3d_coords"	=> array (
		"type"	=> OA::COORD3D_T,
		"detail"	=> true,
	),
);

static private $m_refby = array (
	"HostGroup"		=> array ( "members", ),
	"Service"		=> array ( "host_name", ),
	"ServiceGroup"		=> array ( "members", ),
	"ServiceDependency"	=> array ( "host_name", ),
	"ServiceEscalation"	=> array ( "host_name", ),
	"HostDependency"	=> array ( "dependent_host_name", "host_name", ),
	"HostEscalation"	=> array ( "host_name", ),
	"HostExtInfo"		=> array ( "host_name", ),
	"ServiceExtInfo"	=> array ( "host_name", ),
	// from v1.0.1: parents are handled as a special case
);

static private $m_impliedInheritance = array (
);

};
?>
