<?php
include_once "nagiosobject.class.php";

class HostGroup extends NagiosObject
{
public function __construct()
{
	parent::__construct();
	$this->m_attrdef2 = HostGroup::$m_attrdef;
	$this->m_objtype  = "HostGroup";
	$this->m_objidref =& HostGroup::$m_objid;
	$this->m_refby2   =& HostGroup::$m_refby;
	$this->m_hasDetails = true;
	$this->m_implied2 =& HostGroup::$m_impliedInheritance;
}

static private $m_objid = 0;

static private $m_attrdef = array (

	"hostgroup_name"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_MANDINDEX,
	),
	"__cfgfile" 	=> array ( 
		"type" 	=> OA::CFGFILE_T,
		"flag" 	=> OA::NOT_DUMPMAND,
	),
	"name"		=> array ( 
		"type"	=> OA::SYMBOL_T, 
		"flag"	=> OA::DONT_INHERIT,
	),
	"register"		=> array ( 
		"type"	=> OA::BOOL_T,
		"flag"	=> OA::DONT_INHERIT,
		"default"	=> "yes",
	),
	"use"		=> array ( 
		"type" 	=> OA::HOSTGRPTEMPL_T 
	),
	"alias"		=> array (
		"type"	=> OA::COMMENT_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	# TODO: From nagios v2.8: this field may be multiple
	"members"	=> array (
		"type"	=> OA::HOSTLIST_T,
		"flag"	=> OA::IS_MANDSTAR,
	),
	# New from nagios 3.0:
	"hostgroup_members"	=> array (
		"type"	=> OA::HOSTGRPLIST_T,
	),
	"notes"		=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"notes_url"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"action_url"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
);

static private $m_refby = array (
	"Host"			=> array ( "hostgroups", ),
# removed from nagios v2.8 but re-added from nagios v3.0
	"HostEscalation"	=> array ( "hostgroup_name", ),
	"HostDependency"	=> array ( "dependent_hostgroup_name", ), # from nagios v3.0
	"HostDependency"	=> array ( "hostgroup_name", ), # from nagios v3.0
	"ServiceDependency"	=> array ( "dependent_hostgroup_name", ), # from nagios v3.0
	"ServiceDependency"	=> array ( "hostgroup_name", ), # from nagios v3.0
);

static private $m_impliedInheritance = array (
);

};
?>
