<?php
class MainParms 
{
const NUMERIC_T 	= 1;
const FILENAME_T	= 2;
const DIRNAME_T		= 3;
const BOOL_T		= 4;
const LOGMETHOD_T	= 5;
const UID_T		= 6;
const GID_T		= 7;
const INTERVAL_T	= 8;
const COMMAND_T		= 9;
const TEXT_T		= 10;
const INTERCHECK_T	= 11;
const INTERLEAVE_T	= 12;
const PERCENT_T		= 13;
const FILEMODE_T	= 14;
const DATEFORMAT_T	= 15;

const SINGLE		= 0x1;
const MULTIPLE		= 0x2;

public function __construct()
{
}

public function __destruct() 
{
}

public function GetDef()
{
	return MainParms::$m_mainOptions;
}

public function SetAttr($attr,$value)
{
	$this->m_attr[$attr] = $value;
}

public function IsValidParm($parm)
{
	foreach (MainParms::$m_mainOptions as $key => $def) {
		if ($parm == $key) return true;
	}
	
	return false;
}

private $m_attr = array();

// Array of main options:
static private $m_mainOptions = array(
	"log_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	// All the cfg_file must be processed
	"cfg_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::MULTIPLE,
		"dflt"	=> "",
	),
	// Scan recursively the directories and consider .cfg as config files:
	"cfg_dir"	=> array (
		"type"	=> MainParms::DIRNAME_T,
		"flag"	=> MainParms::MULTIPLE,
		"dflt"	=> "",
	),
	"object_cache_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"resource_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"temp_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"status_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"aggregate_status_updates"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"status_update_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "5",
	),
	"nagios_user"	=> array (
		"type"	=> MainParms::UID_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"nagios_group"	=> array (
		"type"	=> MainParms::GID_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"enable_notifications"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"execute_service_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"accept_passive_service_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"execute_host_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"accept_passive_host_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"enable_event_handlers"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"log_rotation_method"	=> array (
		"type"	=> MainParms::LOGMETHOD_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "n",
	),
	"log_archive_path"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_external_commands"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"command_check_interval"	=> array (
		"type"	=> MainParms::INTERVAL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"command_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"downtime_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"comment_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"lock_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retain_state_information"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"state_retention_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retention_update_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"use_retained_program_state"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"use_retained_scheduling_info"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"use_syslog"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"log_notifications"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"log_service_retries"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"log_host_retries"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"log_event_handlers"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"log_initial_states"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"log_external_commands"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"log_passive_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"global_host_event_handler"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"global_service_event_handler"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"sleep_time"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_inter_check_delay_method"	=> array (
		"type"	=> MainParms::INTERCHECK_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"max_service_check_spread"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_interleave_factor"	=> array (
		"type"	=> MainParms::INTERLEAVE_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "s",
	),
	"max_concurrent_checks"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_reaper_frequency"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"host_inter_check_delay_method"	=> array (
		"type"	=> MainParms::INTERCHECK_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"max_host_check_spread"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"interval_length"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"auto_reschedule_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"auto_rescheduling_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"auto_rescheduling_window"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"use_aggressive_host_checking"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"enable_flap_detection"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"low_service_flap_threshold"	=> array (
		"type"	=> MainParms::PERCENT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"high_service_flap_threshold"	=> array (
		"type"	=> MainParms::PERCENT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"low_host_flap_threshold"	=> array (
		"type"	=> MainParms::PERCENT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"high_host_flap_threshold"	=> array (
		"type"	=> MainParms::PERCENT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"soft_state_dependencies"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"service_check_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"host_check_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"event_handler_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"notification_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"ocsp_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"ochp_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"perfdata_timeout"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"obsess_over_services"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"ocsp_command"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"obsess_over_hosts"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"ochp_command"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"process_performance_data"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"host_perfdata_command"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_perfdata_command"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"host_perfdata_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_perfdata_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"host_perfdata_file_template"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_perfdata_file_template"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"host_perfdata_file_mode"	=> array (
		"type"	=> MainParms::FILEMODE_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "a",
	),
	"service_perfdata_file_mode"	=> array (
		"type"	=> MainParms::FILEMODE_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "a",
	),
	"host_perfdata_file_processing_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"service_perfdata_file_processing_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"host_perfdata_file_processing_command"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"service_perfdata_file_processing_command"	=> array (
		"type"	=> MainParms::COMMAND_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_for_orphaned_services"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"check_service_freshness"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"service_freshness_check_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_host_freshness"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"host_freshness_check_interval"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_service_freshness"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"date_format"	=> array (
		"type"	=> MainParms::DATEFORMAT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "us",
	),
	"check_service_freshness"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "1",
	),
	"illegal_object_name_chars"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"illegal_macro_output_chars"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"use_regexp_matching"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"use_true_regexp_matching"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "0",
	),
	"admin_email"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"admin_pager"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	// Added from v1.0.1 (nagios v3)
	"debug_level"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"debug_verbosity"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"max_debug_file_size"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"debug_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"enable_environment_macros"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"use_large_installation_tweaks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"daemon_dumps_core"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"enable_embedded_perl"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"use_embedded_perl_implicitly"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"p1_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"additional_freshness_latency"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_for_orphaned_hosts"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_for_orphaned_services"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"translate_passive_host_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"passive_host_checks_are_soft"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retained_host_attribute_mask"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retained_service_attribute_mask"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retained_process_host_attribute_mask"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retained_process_service_attribute_mask"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retained_contact_host_attribute_mask"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"retained_contact_service_attribute_mask"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"precached_object_file"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"external_command_buffer_slots"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"temp_path"	=> array (
		"type"	=> MainParms::DIRNAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"event_broker_options"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_result_reaper_frequency"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"max_check_result_reaper_time"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"check_result_path"	=> array (
		"type"	=> MainParms::FILENAME_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"max_check_result_file_age"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"cached_host_check_horizon"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"cached_service_check_horizon"	=> array (
		"type"	=> MainParms::NUMERIC_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"enable_predictive_host_dependency_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	"enable_predictive_service_dependency_checks"	=> array (
		"type"	=> MainParms::BOOL_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
	// Added from v1.0.3 (nagios v3)
	"broker_module"	=> array (
		"type"	=> MainParms::TEXT_T,
		"flag"	=> MainParms::SINGLE,
		"dflt"	=> "",
	),
);
	
};
?>
