<?php
include_once "nagiosobject.class.php";

class Service extends NagiosObject
{
public function __construct()
{
	parent::__construct();
	$this->m_attrdef2 = Service::$m_attrdef;
	$this->m_objtype  = "Service";
	$this->m_objidref =& Service::$m_objid;
	$this->m_refby2   =& Service::$m_refby;
	$this->m_implied2 =& Service::$m_impliedInheritance;
	$this->m_hasDetails = true;
}

/*
public function GetReferences($db,&$attrvalues,&$ref)
{
	parent::GetReferences($db,$attrvalues,$ref);
}
*/

static private $m_objid = 0;

static private $m_attrdef = array (

	"service_description"	=> array (
		"type"	=> OA::SYMBOL_T,
		"flag"	=> OA::IS_MANDINDEX,
	),
	"host_name"		=> array (
		"type"	=> OA::HOSTLIST_T,
		"flag"	=> OA::IS_SEMIMANDINDEXSTAR,
		"mandgrp"	=> 1,
	),
	"hostgroup_name"		=> array (
		"type"	=> OA::HOSTGRPLIST_T,
		"flag"	=> OA::IS_SEMIMANDINDEX,
		"mandgrp"	=> 1,
	),
	"__cfgfile" 	=> array ( 
		"type" 	=> OA::CFGFILE_T,
		"flag" 	=> OA::NOT_DUMPMAND,
	),
	"name"		=> array ( 
		"type"	=> OA::SYMBOL_T, 
		"flag"	=> OA::DONT_INHERIT,
	),
	"register"		=> array ( 
		"type"	=> OA::BOOL_T,
		"flag"	=> OA::DONT_INHERIT,
		"default"	=> "yes",
		"detail"	=> true,
	),
	"use"		=> array ( 
		"type" 	=> OA::SERVTEMPL_T 
	),
	# new from Nagios v3.0
	"display_name"	=> array (
		"type"	=> OA::SYMBOL_T,
	),
	"servicegroups"	=> array (
		"type"	=> OA::HOSTSRVLIST_T,
		"detail"	=> true,
	),
	"is_volatile"		=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"check_command"		=> array (
		"type"	=> OA::COMMAND_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	# new from Nagios v3.0
	"initial_state"		=> array (
		"type"	=> OA::SRVSTALKOPT_T,
		"detail"	=> true,
	),
	"max_check_attempts"	=> array (
		"type"	=> OA::NUMERIC_T,
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
	),
	# from Nagios v3.0 normal_check_interval changed
	"check_interval"	=> array (
		"type"	=> OA::NUMERIC_T,
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
		"unit" 	=> "minutes",
	),
	# from Nagios v3.0 retry_check_interval changed
	"retry_interval"	=> array (
		"type"	=> OA::NUMERIC_T,
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
		"unit" 	=> "minutes",
	),
	"active_checks_enabled"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"passive_checks_enabled"	=> array (
		"type" 	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"check_period"		=> array (
		"type"	=> OA::TIMEPERIOD_T,
		"flag"	=> OA::IS_MANDATORY,
	),
	# Suppressed from nagios v3.0
	#"parallelize_check"	=> array (
	#	"type" 	=> OA::BOOL_T,
	#	"detail"	=> true,
	#),
	"obsess_over_service"	=> array (
		"type" 	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"check_freshness"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"freshness_threshold"	=> array (
		"type"	=> OA::NUMERIC_T,
		"detail"	=> true,
		"unit" 	=> "seconds",
	),
	"event_handler"		=> array (
		"type"	=> OA::COMMAND_T,
		"detail"	=> true,
	),
	"event_handler_enabled"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"low_flap_threshold"	=> array (
		"type"	=> OA::PERCENT_T,
		"detail"	=> true,
	),
	"high_flap_threshold"	=> array (
		"type"	=> OA::PERCENT_T,
		"detail"	=> true,
	),
	"flap_detection_enabled"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	# new from Nagios v3.0
	"flap_detection_options"	=> array ( 
		"type"	=> OA::SRVSTALKOPT_T,
		"detail"	=> true,
	),
	"process_perf_data"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"retain_status_information"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"retain_nonstatus_information"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	"notification_interval"	=> array (
		"type"  => OA::NUMERIC_T,
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
		"unit"	=> "minutes",
	),
	# new from Nagios v3.0
	"first_notification_delay"	=> array (
		"type"	=> OA::NUMERIC_T,
		"detail"	=> true,
		"unit" 	=> "minutes",
	),
	"notification_period"	=> array (
		"type" 	=> OA::TIMEPERIOD_T,
		"flag"	=> OA::IS_MANDATORY,
		"detail"	=> true,
	),
	"notification_options"	=> array (
		"type"	=> OA::SRVNOTIFOPT_T,
		"detail"	=> true,
	),
	"notifications_enabled"	=> array (
		"type"	=> OA::BOOL_T,
		"detail"	=> true,
	),
	# new from Nagios v3.0
	"contacts"	=> array (
		"type"	=> OA::CONTACTLIST_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mangrp" => 2,
	),
	"contact_groups"	=> array (
		"type"	=> OA::CONTACTGRPLIST_T,
		"flag"	=> OA::IS_SEMIMAND,
		"mangrp" => 2,
	),
	"stalking_options"	=> array (
		"type"	=> OA::SRVSTALKOPT_T,
		"detail"	=> true,
	),
	# All the following are new from Nagios v3.0
	"notes"		=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"notes_url"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"action_url"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
	"icon_image"	=> array (
		"type"	=> OA::IMAGE_T,
		"detail"	=> true,
	),
	"icon_image_alt"	=> array (
		"type"	=> OA::COMMENT_T,
		"detail"	=> true,
	),
);

static private $m_refby = array (
	# members = host1,service1,host2,service2...
	"ServiceGroup"		=> array ( "members", ),
	# new in v3: hostgroup_name are also possible
	"ServiceDependency"	=> array ( "dependent_host_name/dependent_service_description", "host_name/service_description", ),
	"ServiceEscalation"	=> array ( "host_name/service_description", ),
	"ServiceExtInfo"	=> array ( "host_name/service_description", ),
);

static private $m_impliedInheritance = array (
    "contact_groups"        => array ( "refattr" => "host_name", "objtype" => "Host", "attrname" => "contact_groups" ),
    "notification_interval" => array ( "refattr" => "host_name", "objtype" => "Host", "attrname" => "notification_interval" ),
    "notification_period"   => array ( "refattr" => "host_name", "objtype" => "Host", "attrname" => "notification_period" ),
    "check_interval"        => array ( "refattr" => "host_name", "objtype" => "Host", "attrname" => "check_interval" ),
    "retry_interval"        => array ( "refattr" => "host_name", "objtype" => "Host", "attrname" => "retry_interval" ),
);

};
?>
