<?php
abstract class ActionBase
{
public function __construct()
{
    	$this->m_disabled = "";
	$this->m_onevent = "";
}

public function __destruct()
{
}

public function getOutput()
{
	return $this->m_output;
}

public function Output($msg)
{
	$this->m_output .= $msg;
}

public function IsInherited($inh)
{
	$this->m_isInherited = $inh;
	$this->m_disabled = "";
	if ($this->m_isInherited) $this->m_disabled = "disabled=disabled";
}

public function SetOnChange($onchange)
{
	if ($onchange) { 
		$this->m_onchange = "readonly $onchange";
	}
}

//
// Note: these functions should be located in displayobject.inc.php...
//
public function DisplayConfigFile($attr,$displayValue)
{
	global $gDB;
	
	$this->Output("<select class=formItem name='$attr' $this->m_onchange $this->m_disabled>");
	try {
		$filelist = $gDB->GetConfigFileList();
		foreach ($filelist as $file) {
			$sel = "";
			if ($displayValue == $file['filename']) $sel = "selected";
			$val = htmlspecialchars($file['filename']);
			$this->Output("<option $sel  value='$val'>$val</option>\n");
		}
	}
	catch (Exception $e) {
		$this->Output("Database error: ".$e->getMessage());
	}
	$this->Output("</select>\n");
}

public function DisplaySymbol($attr,$displayValue)
{
	$val = htmlspecialchars($displayValue);
	$this->Output("<input class=formItem type=text name='$attr' value='$val' size=48 $this->m_onchange $this->m_disabled>\n");
}

public function DisplayComment($attr,$displayValue)
{
	// From v1.0.1: changed value='$val' into value=\"$val\"
	//$val = htmlspecialchars($displayValue);
	// From v1.0.4: fixed for handling quotes inside values:
	$val = htmlentities($displayValue,ENT_QUOTES);
	$this->Output("<input class=formItem type=text name='$attr' value=\"$val\" size=64 $this->m_onchange $this->m_disabled>\n");

	// Hack from v0.10 to display a button after the command_line when creating a new command:
	if ($attr == "command_line") 
		$this->Output("&nbsp;<input type=button class=button onClick=\"chooser=window.open('/eznag/index.php?action=viewplugins&__nomenu=1','CommandList','menubar=no,scrollbars=yes,toolbar=no,width=550,height=440');\" value=\"View Plugins\">");
}

// Added from v0.10:
public function DisplayCommand($attr,$displayValue)
{
	global $gNagiosBaseURL;

	// From v1.0.4: fixed for handling quotes inside values:
	//$val = htmlspecialchars($displayValue);
	$val = htmlentities($displayValue,ENT_QUOTES);
	$this->Output("<input class=formItem type=text name='$attr' value='$val' size=64 $this->m_onchange $this->m_disabled>\n");
	// new look from v1.0.1
	//$this->Output("&nbsp;<input type=button class=button onClick=\"chooser=window.open('/eznag/index.php?action=viewcommands&__nomenu=1','CommandList','menubar=no,scrollbars=yes,toolbar=no,width=550,height=440');\" value=\"View Commands\">");
	$this->Output("&nbsp;<input type=button class=button onClick=\"var win = new Window({className: 'mac_os_x', title: 'Command List', top:70, left:100, width:650, height:440, url: '/eznag/index.php?action=viewcommands&__nomenu=1', showEffectOptions: {duration:1.5}}); win.show();\" value=\"View Commands\">");
}

public function DisplayIPAddr($attr,$displayValue)
{
	$this->Output("<input class=formItem type=text name='$attr' value='$displayValue' size=16 $this->m_onchange $this->m_disabled> (IP Address)\n");
}

public function DisplayNumeric($attr,$displayValue)
{
	$this->Output("<input class=formItem type=text name='$attr' value='$displayValue' size=8 $this->m_onchange $this->m_disabled> (Numeric)\n");
}

public function DisplayBool($attr,$displayValue)
{
	$yes = $no = $dflt = "";
	
	//echo "|$displayValue|";
	if ($displayValue === "0") {
		$no = "checked";
	}
	else if ($displayValue != "") {
		$yes = "checked"; 
	}
	else {
		$dflt = "checked";
	}
	$this->Output("<input type=radio name='$attr' value='1' $yes $this->m_onchange $this->m_disabled> Yes\n");
	$this->Output("<input type=radio name='$attr' value='0' $no $this->m_onchange $this->m_disabled> No\n");
	//echo "<input type=radio name='$attr' value='dflt' $dflt> Default\n";
}

public function DisplayPercent($attr,$displayValue)
{
	$this->Output("<input class=formItem type=text name='$attr' value='$displayValue' size=8 $this->m_onchange $this->m_disabled> (Percentage)\n");
}

public function Display2DCoord($attr,$displayValue)
{
	$coords = explode(",",$displayValue);
	if (!isset($coords[0])) $coords[0] = "";
	if (!isset($coords[1])) $coords[1] = "";
	$this->Output("X=<input class=formItem type=text name='${attr}_x' value='${coords[0]}' size=5 $this->m_onchange $this->m_disabled> ");
	$this->Output("Y=<input class=formItem type=text name='${attr}_y' value='${coords[1]}' size=5 $this->m_onchange $this->m_disabled> (Integers)");	
}

public function Display3DCoord($attr,$displayValue)
{
	$coords = explode(",",$displayValue);
	if (!isset($coords[0])) $coords[0] = "";
	if (!isset($coords[1])) $coords[1] = "";
	if (!isset($coords[2])) $coords[2] = "";
	$this->Output("X=<input class=formItem type=text name='${attr}_x' value='${coords[0]}' size=5 $this->m_onchange $this->m_disabled> ");
	$this->Output("Y=<input class=formItem type=text name='${attr}_y' value='${coords[1]}' size=5 $this->m_onchange $this->m_disabled> ");	
	$this->Output("Z=<input class=formItem type=text name='${attr}_z' value='${coords[2]}' size=5 $this->m_onchange $this->m_disabled> (Floats)");	
}

public function DisplayImage($attr,$displayValue)
{
	global $gNagiosBaseURL;
	
	$this->DisplayComment($attr,$displayValue);
	// new look from v1.0.1
	//$this->Output("&nbsp;<input type=button class=button onClick=\"chooser=window.open('$gNagiosBaseURL/images/logos/index.php?idx=$attrrank','ImageList','menubar=no,scrollbars=yes,toolbar=no,width=490,height=300');\" value=\"Image Select\">");
	$this->Output("&nbsp;<input type=button class=button onClick=\"chooser = new Window({id: 'picker', destroyOnClose: true, className: 'mac_os_x', title: 'Image List', top:70, left:100, width:490, height:300, url: '$gNagiosBaseURL/images/logos/index.php', showEffectOptions: {duration:1.5} }); chooser.show();\" value=\"Pick Image\">");
}

public function DisplayTimeRangeList($attr,$displayValue)
{
	$this->Output("<input class=formItem type=text name='$attr' value='$displayValue' size=32 $this->m_onchange $this->m_disabled>\n");
}

public function DisplayTemplateList($attr,$objtype,$displayValue)
{
	global $gDB;
	
	try {
		$objlist = $gDB->GetObjectOfType($objtype);
	}
	catch (Exception $e) {
		$this->Output("Internal Error: ".$e->getMessage());
		return;
	}
	$this->Output("<select class=formItem name='$attr' $this->m_onchange $this->m_disabled>\n");
	
	// Add the empty choice:
	// it may be the selected one:
	$sel = "";
	if (empty($displayValue)) $sel = "selected";
	$this->Output("<option value='' $sel></option>\n");
	
	foreach ($objlist as $obj) {
		if (!$obj['register'] && $obj['name'] != "") {
			$sel = "";
			if ($displayValue == $obj['name'])
				$sel = "selected";
			$this->Output("<option value='${obj['name']}' $sel>${obj['name']}</option>\n");
		}
	}
	
	$this->Output("</select>\n");
}

public function DisplaySingleListServiceExtInfo($attr,$objtype,$displayValue)
{
	// Load the Ajax script:
	$this->Output('<script type="text/javascript" src="js/AjaxRequest.js"></script>');
	$this->Output('<script type="text/javascript">');
	$this->Output('function updateService(srvlist) {');
	#$this->Output('alert(srvlist);');
	$this->Output('var l = srvlist.split("||");');
	$this->Output('var sel = document.forms[0].service_description;');
	#$this->Output('alert(sel.length);');
	$this->Output('n=sel.length;for (i=0;i<n;i++) { sel.remove[0]; }');
	$this->output('sel.length=0;');
	#$this->Output('alert(sel.length);');
	$this->Output('for (i=0;i<l.length;i++) {');
	$this->Output('var o=document.createElement("option");o.text=l[i];o.value=l[i];');
	$this->Output('try { sel.add(o,null); } catch(ex) { sel.add(o); }');
	$this->Output('}'); 
	$this->Output('}');
	$this->Output('function submitChange() {');
	$this->Output('var hostname = document.forms[0].host_name.value;');
	$this->Output('AjaxRequest.get({\'url\':\'index.php?action=ajaxgetsrvhost&hostname=\'+hostname,');
	$this->Output('\'onSuccess\':function(req) { updateService(req.responseText); },\'onError\':function(req) { alert("Ajax Error");} })');
	$this->Output('}');
	$this->Output('</script>');
	$this->m_onevent = 'onchange="javascript:submitChange()"';
	$this->DisplaySingleList($attr,$objtype,$displayValue);
	$this->m_onevent = '';
}

public function DisplaySingleList($attr,$objtype,$displayValue)
{
	global $gDB;
	global $gErrorMSG;
	
	try {
		$objlist = $gDB->GetObjectOfType($objtype);
		$dummy = ObjectFactory::Factory($objtype);
		$indexes = $dummy->GetIndex();
		$index = $indexes[count($indexes)-1];
		if ($objtype == "Service") $index = $indexes[0];
	}
	catch (Exception $e) {
		$this->Output("Internal Error: ".$e->getMessage());
		return;
	}
	
	$this->Output("<select class=formItem name='$attr' $this->m_onchange $this->m_onevent $this->m_disabled>\n");
	
	// Add the empty choice:
	// it may be the selected one:
	$sel = "";
	if (empty($displayValue)) $sel = "selected";
	$this->Output("<option value='' $sel></option>\n");
	
	foreach ($objlist as $obj) {
		if ($obj['register'] || $obj['name'] == "") {
			$sel = "";
			if ($displayValue == $obj[$index])
				$sel = "selected";
			$this->Output("<option value='${obj[$index]}' $sel>${obj[$index]}</option>\n");
		}
	}
	
	$this->Output("</select>\n");
}

public function DisplayMultipleList($parenttype,$mainkey,$attr,$objtype,$displayValue)
{
	global $gDB;
	global $gMultiSelectRows;
		
	try {
		$dummy = ObjectFactory::Factory($objtype);
		$parent = ObjectFactory::factory($parenttype);
		$indexes = $dummy->GetIndex();
		$index = $indexes[0];
		$objlist = $gDB->GetObjectOfType($objtype);
	}
	catch (Exception $e) {
		$this->Output("Internal Error: ".$e.getMessage());
		return;
	}
	
	// added with v0.5:
	//$elements = explode(",",$displayValue);
	if (is_array($displayValue))
		$elements = $displayValue;
	else
		$elements = explode(",",$displayValue);
	
	$this->Output("<select class=formItem multiple size=$gMultiSelectRows name='${attr}[]' $this->m_onchange $this->m_disabled>\n");
	
	// Add the empty choice:
	// it may be the selected one:
	$sel = "";
	if (empty($displayValue)) $sel = "selected";
	$this->Output("<option value='' $sel></option>\n");
	
	// Handle the SUPPORT_STAR flag:
	$parentattr = $parent->GetDef();
	if (isset($parentattr[$attr]['flag']) && 
	    ($parentattr[$attr]['flag'] & OA::SUPPORT_STAR)) {
		$sel = "";
		if (in_array("*",$elements)) $sel = "selected";
		$this->Output("<option value='*' $sel>*</option>\n");
	}
	
	foreach ($objlist as $obj) {
		// The used attribute is the first index:
		$curname = $obj[$index];
		
		// Hack: if $attr is 'parent', do not display the object name
		//       in the list (one could not be its own parent !)
		if ($attr == "parents") {
			if ($curname == $mainkey)
				continue;
		}
				
		if ($obj['register'] || $obj['name'] == "") {
			$sel = "";
			if (in_array($curname,$elements)) $sel = "selected";
			$this->Output("<option value='$curname' $sel>$curname</option>\n");
		}
	}
	
	$this->Output("</select>\n");
}

public function DisplayEscalationHostOptions($attr,$displayValue)
{
	$su = $sr = $sd = "";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"r")) $sr = "checked";
	if (strstr($displayValue,"d")) $sd = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=hostescal_u value=u $su $this->m_onchange $this->m_disabled> Escalate on an unreachable state<br>");
	$this->Output("<input type=checkbox name=hostescal_r value=r $sr $this->m_onchange $this->m_disabled> Escalate on recoveries (back to up state)<br>");
	$this->Output("<input type=checkbox name=hostescal_d value=d $sd $this->m_onchange $this->m_disabled> Escalate on down state<br>\n");
	$this->Output("</fieldset>");
}

public function DisplayEscalationServiceOptions($attr,$displayValue)
{
	$su = $sr = $sw = $sc = "";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"r")) $sr = "checked";
	if (strstr($displayValue,"w")) $sw = "checked";
	if (strstr($displayValue,"c")) $sc = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=srvescal_u value=u $su $this->m_onchange $this->m_disabled> Escalate on an unknown state<br>");
	$this->Output("<input type=checkbox name=srvescal_r value=r $sr $this->m_onchange $this->m_disabled> Escalate on recoveries (back to up state)<br>");
	$this->Output("<input type=checkbox name=srvescal_w value=d $sw $this->m_onchange $this->m_disabled> Escalate on a warning state<br>\n");
	$this->Output("<input type=checkbox name=srvescal_c value=d $sw $this->m_onchange $this->m_disabled> Escalate on a critical state<br>\n");
	$this->Output("</fieldset>");
}

public function DisplayHostFailureCriteria($attr,$displayValue)
{
	$so = $sd = $su = $sp = $sn = "";
	if (strstr($displayValue,"o")) $so = "checked";
	if (strstr($displayValue,"d")) $sd = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"p")) $sp = "checked";
	if (strstr($displayValue,"n")) $sn = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=hostfail_o value=o $so $this->m_onchange $this->m_disabled> fail on an UP state state<br>");
	$this->Output("<input type=checkbox name=hostfail_d value=d $sd $this->m_onchange $this->m_disabled> fail on a DOWN state<br>");
	$this->Output("<input type=checkbox name=hostfail_u value=u $su $this->m_onchange $this->m_disabled> fail on an UNREACHABLE state<br>\n");
	$this->Output("<input type=checkbox name=hostfail_p value=p $sp $this->m_onchange $this->m_disabled> fail on a pending state<br>\n");
	$this->Output("<input type=checkbox name=hostfail_n value=n $sn $this->m_onchange $this->m_disabled> none (dependent host will be always checked)<br>\n");
	$this->Output("</fieldset>");
}

public function DisplayServiceFailureCriteria($attr,$displayValue)
{
	$so = $sw = $su = $sc = $sp = $sn = "";
	if (strstr($displayValue,"o")) $so = "checked";
	if (strstr($displayValue,"w")) $sw = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"c")) $sc = "checked";
	if (strstr($displayValue,"p")) $sp = "checked";
	if (strstr($displayValue,"n")) $sn = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=srvfail_o value=o $so $this->m_onchange $this->m_disabled> fail on an UP state state<br>");
	$this->Output("<input type=checkbox name=srvfail_w value=w $sw $this->m_onchange $this->m_disabled> fail on a DOWN state<br>");
	$this->Output("<input type=checkbox name=srvfail_u value=u $su $this->m_onchange $this->m_disabled> fail on an UNKNOWN state<br>\n");
	$this->Output("<input type=checkbox name=srvfail_c value=c $sc $this->m_onchange $this->m_disabled> fail on an CRITICAL state<br>\n");
	$this->Output("<input type=checkbox name=srvfail_p value=p $sp $this->m_onchange $this->m_disabled> fail on a pending state<br>\n");
	$this->Output("<input type=checkbox name=srvfail_n value=n $sn $this->m_onchange $this->m_disabled> none (dependent host will be always checked)<br>\n");
	$this->Output("</fieldset>");
}

public function DisplayHostStalkOptions($attr,$displayValue)
{
	$so = $sd = $su = "";
	if (strstr($displayValue,"o")) $so = "checked";
	if (strstr($displayValue,"d")) $sd = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=stalk_o value=o $so $this->m_onchange $this->m_disabled> Stalk on UP states<br>");
	$this->Output("<input type=checkbox name=stalk_d value=w $sd $this->m_onchange $this->m_disabled> Stalk on DOWN states<br>");
	$this->Output("<input type=checkbox name=stalk_u value=u $su $this->m_onchange $this->m_disabled> Stalk on UNREACHABLE states<br>");
	$this->Output("</fieldset>");
}

public function DisplayServiceStalkOptions($attr,$displayValue)
{
	$so = $sw = $su = $sc = "";
	if (strstr($displayValue,"o")) $so = "checked";
	if (strstr($displayValue,"w")) $sw = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"c")) $sc = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=stalk_o value=o $so $this->m_onchange $this->m_disabled> Stalk on OK states<br>");
	$this->Output("<input type=checkbox name=stalk_w value=w $sw $this->m_onchange $this->m_disabled> Stalk on WARNING states<br>");
	$this->Output("<input type=checkbox name=stalk_u value=u $su $this->m_onchange $this->m_disabled> Stalk on UNKNOWN states<br>");
	$this->Output("<input type=checkbox name=stalk_c value=c $sc $this->m_onchange $this->m_disabled> Stalk on CRITICAL states<br>");
	$this->Output("</fieldset>");
}

public function DisplayNotificationOptions($attr,$displayValue)
{
	$sd = $su = $sr = "";
	if (strstr($displayValue,"d")) $sd = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"r")) $sr = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=notif_d value=d $sd $this->m_onchange $this->m_disabled> Send on a down state<br>");
	$this->Output("<input type=checkbox name=notif_u value=u $su $this->m_onchange $this->m_disabled> Send on an unreachable state<br>");
	$this->Output("<input type=checkbox name=notif_r value=r $sr $this->m_onchange $this->m_disabled> Send on recoveries (back to up state)<br>");
	$this->Output("</fieldset>");
}

public function DisplayHostNotificationOptions($attr,$displayValue)
{
	$sd = $su = $sr = $sf = $ss = $sn = "";
	if (strstr($displayValue,"d")) $sd = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"r")) $sr = "checked";
	if (strstr($displayValue,"f")) $sf = "checked";
	if (strstr($displayValue,"s")) $ss = "checked";
	if (strstr($displayValue,"n")) $sn = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=hostnotif_d value=d $sd $this->m_onchange $this->m_disabled> Send on a down state<br>\n");
	$this->Output("<input type=checkbox name=hostnotif_u value=u $su $this->m_onchange $this->m_disabled> Send on an unreachable state<br>\n");
	$this->Output("<input type=checkbox name=hostnotif_r value=r $sr $this->m_onchange $this->m_disabled> Send on recoveries (back to up state)<br>\n");
	$this->Output("<input type=checkbox name=hostnotif_f value=f $sf $this->m_onchange $this->m_disabled> Send on flapping<br>\n");
	$this->Output("<input type=checkbox name=hostnotif_s value=s $ss $this->m_onchange $this->m_disabled> Send on Scheduled Downtime starts/ends<br>\n");
	$this->Output("<input type=checkbox name=hostnotif_n value=n $sn $this->m_onchange $this->m_disabled> No notification<br>\n");
	$this->Output("</fieldset>");
}

public function DisplayServiceNotificationOptions($attr,$displayValue)
{
	$sw = $su = $sc = $sr = $sf = $ss = $sn = "";
	if (strstr($displayValue,"w")) $sw = "checked";
	if (strstr($displayValue,"u")) $su = "checked";
	if (strstr($displayValue,"c")) $sc = "checked";
	if (strstr($displayValue,"r")) $sr = "checked";
	if (strstr($displayValue,"f")) $sf = "checked";
	if (strstr($displayValue,"s")) $ss = "checked"; /* bug fixed from v1.0.1: $sf instead */
	if (strstr($displayValue,"n")) $sn = "checked";
	$this->Output("<fieldset name=\"$attr\">\n");
	$this->Output("<input type=checkbox name=srvnotif_w value=w $sw $this->m_onchange $this->m_disabled> Send on Warnings<br>");
	$this->Output("<input type=checkbox name=srvnotif_u value=u $su $this->m_onchange $this->m_disabled> Send on Unknown state<br>");
	$this->Output("<input type=checkbox name=srvnotif_c value=c $sc $this->m_onchange $this->m_disabled> Send on Critical state<br>");
	$this->Output("<input type=checkbox name=srvnotif_r value=r $sr $this->m_onchange $this->m_disabled> Send on recoveries (back to up state)<br>");
	$this->Output("<input type=checkbox name=srvnotif_f value=f $sf $this->m_onchange $this->m_disabled> Send on flapping<br>\n");
	$this->Output("<input type=checkbox name=srvnotif_s value=s $ss $this->m_onchange $this->m_disabled> Send on Scheduled Downtime starts/ends<br>\n");
	$this->Output("<input type=checkbox name=srvnotif_n value=n $sn $this->m_onchange $this->m_disabled> No notification<br>\n");
	$this->Output("</fieldset>");
}

public function DisplayCommandOutput(&$output)
{
	if (is_array($output)) {
		$rows = min(20,count($output));
		$this->Output("<div align=left>");
		$this->Output("<textarea class=sysoutput readonly rows=$rows cols=100 $this->m_onchange $this->m_disabled>");
		foreach ($output as $line) {
			$this->Output("$line\n");
		}
		$this->Output("</textarea></div>");
	}
}

// Added from v0.11 to take care on magic_quotes_gpc
public function NormalizeValues(&$attrvalues)
{
	if (!get_magic_quotes_gpc()) return;

	foreach ($attrvalues as $attr => $value) {
		// Bug fixed from v1.0.3: some attrs can be arrays !
		if (is_array($attrvalues[$attr])) {
			for ( $i = 0 ; $i < count($attrvalues[$attr]) ; $i++ ) 
				$attrvalues[$attr][$i] = stripslashes($attrvalues[$attr][$i]);
		}
		else {
			$attrvalues[$attr] = stripslashes($value);
		}
	}
}

// Moved here from configure.php since v1.0.1
protected function UpdateConfFile($confname,&$lines)
{
        global $gErrorMSG;
	global $gLogger;

        # Set a lock if more than one Admin try to change the prefs...
	$lockname = "$confname.lock";
	if (!($flock = @fopen($lockname,"w"))) {
		$gLogger->Log("Could not open Lock '$lockname' in write mode");
	}
	else {
		if (!@flock($flock,LOCK_EX))
			$gLogger->Log("Could not set a lock on '$lockname'");
	}

        # Get the permissions of the current file:
        list($dev,$ino,$mode,$nlink,$uid,$gid) = @stat("$confname");

        $newname = "$confname.new";
        if (!($fd = @fopen("$newname","w"))) {
                $gErrorMSG = "Could not open file '$newname'";
		if ($flock) {
			@flock($flock,LOCK_UN);
			@fclose($flock);
		}
		return false;
        }

	$ok = true;
	foreach ($lines as $l) {
		if (!fwrite($fd,$l)) {
			$gErrorMSG = "Write error in file '$newname'";
			$ok = false;
			break;
		}
	}
	@fclose($fd);

	if ($ok) {
		if (!@rename("$newname","$confname")) {
			$gErrorMSG = "Could not rename '$newname' into '$confname'";
			$ok = false;
		}

		# Set the original permissions:
		if (!chmod("$confname",$mode)) {
			$gErrorMSG = "Could not set permissions '$mode' to '$confname'";
			$ok = false;
		}
        }

	if ($flock) {
		@flock($flock,LOCK_UN);
		@fclose($flock);
	}

	return $ok;
}

// Run() is called after header inclusion
abstract public function Run();

private $m_output;
private $m_onchange;
};
