<?php
#
# Run nmap and parse the XML Output.
# Returns a HTML page with the detected host and service list.
#
# Note: apache must have the sudo right for nmap !
#
include_once "actionbase.inc.php";
include_once "nmap.inc.php";

// Variable used by the XML callback functions:
$gHosts = array();
$curaddr = "";
$curproto = "";
$cuport = "";
$curname = "";
$insideHost = false;

class Action extends ActionBase
{
public $m_sigs = array (
		'tcp'  => array (
				'req' => false, 
				'type' => 'string',
				),
		'tcpport'  => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'nmapstring'
				),
		'udp'  => array (
				'req' => false, 
				'type' => 'string',
				),
		'udpport'  => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'nmapstring'
				),
		'netaddr'  => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'nmapstring'
				),
	);

public function Run()
{
	global $gNmapCommand;
	global $nmap_lock_file;
	global $nmap_tcp_result;
	global $nmap_udp_result;

	$_REQUEST['__ajax'] = 1;

	if (file_exists($nmap_lock_file)) {
		echo "ERROR: Nmap is already running";
		return;
	}
	touch($nmap_lock_file);

	@unlink($nmap_tcp_result);
	@unlink($nmap_udp_result);

	if (isset($_REQUEST['tcp']) && $_REQUEST['tcp'] == 'true' && !empty($_REQUEST['tcpport'])) {
		$parms = "-sS -p ".$_REQUEST['tcpport']." ".$_REQUEST['netaddr'];
		$cmd = "sudo $gNmapCommand -oX $nmap_tcp_result $parms >/dev/null &";
		$lastline = @exec($cmd,$output,$status);
	}

	if (isset($_REQUEST['udp']) && $_REQUEST['udp'] == 'true' && !empty($_REQUEST['udpport'])) {
		$parms = "-sU -p ".$_REQUEST['udpport']." ".$_REQUEST['netaddr'];
		$cmd = "sudo $gNmapCommand -oX $nmap_udp_result $parms >/dev/null &";
		$lastline = @exec($cmd,$output,$status);
	}

	echo "Nmap process started";
}

};

?>
