<?php
include_once "actionbase.inc.php";
include_once "nmap.inc.php";

class Action extends ActionBase
{
public $m_sigs = array();

private $m_confsigs = array (
			'dbfile' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Database File Location',
					'varname' => 'gDBFile',
					'filter' => 'filename'
					),
			'backupdir' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Backup Directory',
					'varname' => 'gBackupDir',
					'filter' => 'filename'
					),
			'nagstart' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Nagios Start Command',
					'varname' => 'gStartCommand',
					'filter' => 'command'
					),
			'nagstop' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Nagios Stop Command',
					'varname' => 'gStopCommand',
					'filter' => 'command'
					),
			'nagrestart' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Nagios Restart Command',
					'varname' => 'gRestartCommand',
					'filter' => 'command'
					),
			'nagtest' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Nagios Test Configuration',
					'varname' => 'gTestCommand',
					'filter' => 'command'
					),
			'inherit' => array (
					'req' => true, 
					'type' => 'boolean',
					'label' => 'Show Inheritages',
					'varname' => 'gShowInheritedUsage',
					'filter' => 'boolean'
					),
			'references' => array (
					'req' => true, 
					'type' => 'boolean',
					'label' => 'Show References',
					'varname' => 'gShowReferenceUsage',
					'filter' => 'boolean'
					),
			'rowsperlist' => array (
					'req' => true, 
					'type' => 'integer',
					'label' => 'List Row Count',
					'varname' => 'gMultiSelectRows',
					'filter' => 'onlydigit'
					),
			'debug' => array (
					'req' => true, 
					'type' => 'boolean',
					'label' => 'Debug Mode',
					'varname' => 'gDebugMode',
					'filter' => 'boolean'
					),
			);

private $m_nmapsigs = array (
			'nmap_command' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Nmap Command Path',
					'varname' => 'gNmapCommand',
					'filter' => 'filename'
					),
			'host_use_dflt' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Host Template Name',
					'varname' => 'host_use_dflt',
					'filter' => 'nagiosstring'
					),
			'service_use_dflt' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Service Template Name',
					'varname' => 'service_use_dflt',
					'filter' => 'nagiosstring'
					),
			);

			/*
			'host_check_command' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Host Check Command',
					'varname' => 'host_check_command_dflt',
					'filter' => 'nagiosstring'
					),
			'host_contact_group' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Host Contact Group',
					'varname' => 'host_contact_groups_dflt',
					'filter' => 'nagiosstring'
					),
			'host_max_check_attempts' => array (
					'req' => true, 
					'type' => 'integer',
					'label' => 'Host Max Check Attempts',
					'varname' => 'host_max_check_attempts_dflt',
					'filter' => 'integer'
					),
			'host_check_period' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Host Check Period',
					'varname' => 'host_check_period_dflt',
					'filter' => 'nagiosstring'
					),
			'host_notification_interval' => array (
					'req' => true, 
					'type' => 'integer',
					'label' => 'Host Notification Interval',
					'varname' => 'host_notification_interval_dflt',
					'filter' => 'integer'
					),
			'host_notification_period' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Host Notification Period',
					'varname' => 'host_notification_period_dflt',
					'filter' => 'nagiosstring'
					),
			'host_notification_options' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Host Notification Options',
					'varname' => 'host_notification_options_dflt',
					'filter' => 'nagiosstring'
					),
			'host_active_check_enabled' => array (
					'req' => true, 
					'type' => 'boolean',
					'label' => 'Host Active Checks Enabled',
					'varname' => 'host_active_checks_enabled',
					'filter' => 'boolean'
					),
			'host_notifications_enabled' => array (
					'req' => true, 
					'type' => 'boolean',
					'label' => 'Host Notifications Enabled',
					'varname' => 'host_notifications_enabled',
					'filter' => 'boolean'
					),
			);
			*/

#<tr class=oddCell><td>Service is volatile:</td><td class=cell><input class=formItem type=radio name=volatile value=1 $volatileyes> Yes <input type=radio name=volatile value=0 $volatileno> No</td></tr>
#<tr class=evenCell><td>Service Check Period:</td><td class=cell><input class=formItem type=text size=70 name=service_check_period value="${GLOBALS['service_check_period_dflt']}"></td></tr>
#<tr class=oddCell><td>Service Max Check Attempts:</td><td class=cell><input class=formItem type=text size=70 name=service_max_check_attempts value="${GLOBALS['service_max_check_attempts_dflt']}"></td></tr>
#<tr class=evenCell><td>Service Normal Check Interval:</td><td class=cell><input class=formItem type=text size=70 name=service_check_interval value="${GLOBALS['service_normal_check_interval_dflt']}"></td></tr>
#<tr class=oddCell><td>Service Retry Check Interval:</td><td class=cell><input class=formItem type=text size=70 name=service_retry_interval value="${GLOBALS['service_retry_check_interval_dflt']}"></td></tr>
#<tr class=evenCell><td>Service Contact Group:</td><td class=cell><input class=formItem type=text size=70 name=service_contact_group value="${GLOBALS['service_contact_groups_dflt']}"></td></tr>
#<tr class=oddCell><td>Service Notification Interval:</td><td class=cell><input class=formItem type=text size=70 name=service_notification_interval value="${GLOBALS['service_notification_interval_dflt']}"></td></tr>
#<tr class=evenCell><td>Service Notification Period:</td><td class=cell><input class=formItem type=text size=70 name=service_notification_period value="${GLOBALS['service_notification_period_dflt']}"></td></tr>
#<tr class=oddCell><td>Service Notification Options:</td><td class=cell><input class=formItem type=text size=70 name=service_notification_options value="${GLOBALS['service_notification_options_dflt']}"></td></tr>
#<tr class=evenCell><td>Service Notifications Enabled:</td><td class=cell><input class=formItem type=radio name=service_notifications_enabled value=1 $servicenotifyes> Yes <input type=radio name=service_notifications_enabled value=0 $servicenotifno> No</td></tr>
#<tr class=oddCell><td>Service Active Checks Enabled:</td><td class=cell><input class=formItem type=radio name=service_active_check_enabled value=1 $serviceactchkyes> Yes <input type=radio name=service_active_check_enabled value=0 $serviceactchkno> No</td></tr>
#<tr class=evenCell><td>Service Passive Checks Enabled:</td><td class=cell><input class=formItem type=radio name=service_passive_check_enabled value=1 $servicepaschkyes> Yes <input type=radio name=service_passive_check_enabled value=0 $servicepaschkno> No</td></tr>

private $m_rrdsigs = array (
			'rrd_command' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'RRDTool Command',
					'varname' => 'gRRDToolCommand',
					'filter' => 'command'
					),
			'use_rrdtool' => array (
					'req' => true, 
					'type' => 'boolean',
					'label' => 'Generate Graphs',
					'varname' => 'gMakeRRDGraph',
					'filter' => 'boolean'
					),
			'rrd_dir' => array (
					'req' => true, 
					'type' => 'string',
					'label' => 'Graph Directory',
					'varname' => 'gRRDGraphDir',
					'filter' => 'filename'
					),
			);

public function Init()
{
}

public function Run()
{
	$curtab = "Main";

	# Conf files must be writeable:
	if (!is_writeable("config.inc.php")) {
		$GLOBALS['gErrorMSG'] = "File 'config.inc.php' is not writeable via this interface.";
	}
	if (!is_writeable("nmap.inc.php")) {
		$GLOBALS['gErrorMSG'] = "File 'nmap.inc.php' is not writeable via this interface.";
	}
	if (!is_writeable("rrdgraph.inc.php")) {
		$GLOBALS['gErrorMSG'] = "File 'rrdgraph.inc.php' is not writeable via this interface.";
	}

	# Make other sanity checks on parameters:
	if (!is_writeable($GLOBALS['gBackupDir'])) {
		$this->m_confsigs['backupdir']['msg'] = "Backup Directory ${GLOBALS['gBackupDir']} is not writeable via this interface.";
	}
	if ($GLOBALS['gMakeRRDGraph']) {
		if (!is_readable($GLOBALS['gRRDGraphDir'])) {
			$this->m_rrdsigs['rrd_dir']['msg'] = "Backup Directory ${GLOBALS['gRRDGraphDir']} is not readable via this interface.";
		}
	
		# TODO: must be writeable by nagios ! (a bit difficult to test)
	}

	# Form SAVE_CONF submitted ?
	if (isset($_POST['save_conf'])) {
		$curtab = "Main";
		$confname = "config.inc.php";
		$lines = @file("$confname");
		$ok = true;

		include_once "sanitize.inc.php";

		# Sanitize the parameters:
		$ok = SanitizeConfParms($_POST,$this->m_confsigs);

		# Backupdir must be writeable
		$this->m_confsigs['backupdir']['msg'] = "";
		if (!is_writeable($_POST['backupdir'])) {
			$this->m_confsigs['backupdir']['msg'] = "Backup Directory ${_POST['backupdir']} is not writeable via this interface.";
			$ok = false;
		}

		if ($ok) {
                        $lines = preg_replace('/^(\$gDBFile.*=.*")(.*)(".*)/',"\${1}".$_POST['dbfile'].'\3',$lines);
                        $lines = preg_replace('/^(\$gBackupDir.*=.*")(.*)(".*)/',"\${1}".$_POST['backupdir'].'\3',$lines);
                        $lines = preg_replace('/^(\$gStartCommand.*=.*")(.*)(".*)/',"\${1}".$_POST['nagstart'].'\3',$lines);
                        $lines = preg_replace('/^(\$gStopCommand.*=.*")(.*)(".*)/',"\${1}".$_POST['nagstop'].'\3',$lines);
                        $lines = preg_replace('/^(\$gRestartCommand.*=.*")(.*)(".*)/',"\${1}".$_POST['nagrestart'].'\3',$lines);
                        $lines = preg_replace('/^(\$gTestCommand.*=.*")(.*)(".*)/',"\${1}".$_POST['nagtest'].'\3',$lines);
			$value = ($_POST['inherit'])?"true":"false";
                        $lines = preg_replace('/^(\$gShowInheritedUsage.*=[ ]*)([a-z]+)(.*)/',"\${1}".$value.'\3',$lines);
			$value = ($_POST['references'])?"true":"false";
                        $lines = preg_replace('/^(\$gShowReferenceUsage.*=[ ]*)([a-z]+)(.*)/',"\${1}".$value.'\3',$lines);
                        $lines = preg_replace('/^(\$gMultiSelectRows.*=[ ]*)([0-9]+)(.*)/',"\${1}".$_POST['rowsperlist'].'\3',$lines);
			$value = ($_POST['debug'])?"true":"false";
                        $lines = preg_replace('/^(\$gDebugMode.*=[ ]*)([a-z]+)(.*)/',"\${1}".$value.'\3',$lines);

			if ($this->UpdateConfFile($confname,$lines)) {
				include "$confname";	// re-read the conf file
				$GLOBALS['gMSG'] = "Configuration updated";
				$this->UpdateGlobalParms($this->m_confsigs);
			}
                }
	}
	if (isset($_POST['nmap_conf'])) {
		$curtab = "Nmap";
		$confname = "nmap.inc.php";
		$lines = @file("$confname");
		$ok = true;

		include_once "sanitize.inc.php";

		# Sanitize the parameters:
		$ok = SanitizeConfParms($_POST,$this->m_nmapsigs);

		# Nmap command must exist:
		$this->m_nmapsigs['nmap_command']['msg'] = "";
		if (!is_executable($_POST['nmap_command'])) {
			$this->m_nmapsigs['nmap_command']['msg'] = "Nmap Command ${_POST['nmap_command']} not found.";
			$ok = false;
		}

		if ($ok) {
                        $lines = preg_replace('/^(\$gNmapCommand.*=.*")(.*)(".*)/',"\${1}".$_POST['nmap_command'].'\3',$lines);
                        $lines = preg_replace('/^(\$host_use_dflt.*=.*")(.*)(".*)/',"\${1}".$_POST['host_use_dflt'].'\3',$lines);
                        $lines = preg_replace('/^(\$service_use_dflt.*=.*")(.*)(".*)/',"\${1}".$_POST['service_use_dflt'].'\3',$lines);

			if ($this->UpdateConfFile($confname,$lines)) {
				include "$confname";	// re-read the conf file
				$GLOBALS['gMSG'] = "Configuration updated";
				$this->UpdateGlobalParms($this->m_nmapsigs);
			}
                }
	}
	if (isset($_POST['rrd_conf'])) {
		$curtab = "RRDTool";
		$confname = "config.inc.php";
		$lines = @file("$confname");
		$ok = true;

		include_once "sanitize.inc.php";

		# Sanitize the parameters:
		$ok = SanitizeConfParms($_POST,$this->m_rrdsigs);

		# RRDTool command must exist:
		$this->m_rrdsigs['rrd_command']['msg'] = "";
		if (!is_executable($_POST['rrd_command'])) {
			$this->m_rrdsigs['rrd_command']['msg'] = "RRDTool Command ${_POST['rrd_command']} not found.";
			$ok = false;
		}

		if ($ok) {
                        $lines = preg_replace('/^(\$gRRDToolCommand.*=.*")(.*)(".*)/',"\${1}".$_POST['rrd_command'].'\3',$lines);
                        $lines = preg_replace('/^(\$gRRDGraphDir.*=.*")(.*)(".*)/',"\${1}".$_POST['rrd_dir'].'\3',$lines);
			$value = ($_POST['use_rrdtool'])?"true":"false";
                        $lines = preg_replace('/^(\$gMakeRRDGraph.*=[ ]*)([a-z]+)(.*)/',"\${1}".$value.'\3',$lines);

			if ($this->UpdateConfFile($confname,$lines)) {
				include "$confname";	// re-read the conf file
				$GLOBALS['gMSG'] = "Configuration updated";
				$this->UpdateGlobalParms($this->m_rrdsigs);
			}
                }
	}

	# Display Conf Parms:
	$main_conf = $this->BuildParmsOutput($this->m_confsigs,"save_conf");
	$main_conf = addslashes($main_conf);
	$main_conf = ereg_replace("\n","",$main_conf);

	$nmap_conf = $this->BuildParmsOutput($this->m_nmapsigs,"nmap_conf");
	$nmap_conf = addslashes($nmap_conf);
	$nmap_conf = ereg_replace("\n","",$nmap_conf);

	$rrd_conf = $this->BuildParmsOutput($this->m_rrdsigs,"rrd_conf");
	$rrd_conf = addslashes($rrd_conf);
	$rrd_conf = ereg_replace("\n","",$rrd_conf);

$html =<<<END
<script language="JavaScript">
var tabDef = {
	"x": 10, "y" : 10,	// start position of tab
	"width" : 600, "height" : 80,
	"offset" : 10,
	"spacing" : 5,
	"padding" : 5,
	"layout" : "top",	// bottom, left, right, top
	"align" : "center",
	"css" : "common",
	"cssover" : "over",
	"csscurr" : "current",
	"csshint" : "hint",
	"border" : {
		"width" : 1, "color" : "#000000"
	},
	"tabs" : [
	{
		"text" : "Main",
		"hint" : "$main_conf",
		"css" : "commonl",
		"cssover" : "overl",
		"csscurr" : "currentl",
		"csshint" : "hintl",
		"width" : 80,
		"height" : 14
	},
	{
		"text" : "Nmap",
		"hint" : "$nmap_conf",
		"css" : "commonl",
		"cssover" : "overl",
		"csscurr" : "currentl",
		"csshint" : "hintl",
		"width" : 80,
		"height" : 14
	},
	{
		"text" : "RRDTool",
		"hint" : "$rrd_conf",
		"css" : "commonl",
		"cssover" : "overl",
		"csscurr" : "currentl",
		"csshint" : "hintl",
		"width" : 80,
		"height" : 14
	}
	]
};

var ts = new CTabSet("ts");
ts.create(tabDef);
ts.setCurrTab("$curtab");
</script>
END;

	$this->Output($html);
}

private function BuildParmsOutput(&$sigs,$name)
{
$output =<<<END
<form action=index.php?action=configure method=post>
	<table class=main width=100%>
		<tr class=rowhdr><th>Parameter</th><th>Value</th></tr>
END;

	$curline = 0;
	$checked = "checked";

	foreach ($sigs as $parm => $descr) {
		if ($curline % 2)
			$output .= "<tr class=evenCell>";
		else
			$output .= "<tr class=oddCell>";

		$output .= "<td>".$descr['label'].":</td><td class=cell>";

		if (isset($descr['msg']) && !empty($descr['msg'])) {
			$output .= "<div class=errorCell>${descr['msg']}</div>";
		}

		if ($descr['type'] == 'boolean') {

			$yes = $no = "";
			if ($GLOBALS[$descr['varname']]) $yes = $checked;
			else $no = $checked;

			$output .= "<input type=radio name=$parm value=1 $yes> Yes <input type=radio name=$parm value=0 $no> No</td></tr>\n";

		}
		else {
			if ($descr['type'] == 'integer') $size = 3;
			else $size = 70;

			$output .= "<input class=formItem type=text size=$size name=$parm value=\"${GLOBALS[$descr['varname']]}\"></td></tr>\n";
		}

		$curline++;
	}

$output .=<<<END
			<tr><td></td><td><input class=button type=submit name=$name value='Save'></td></tr>
		</table>
	</form>
END;
	return $output;
}

private function UpdateGlobalParms(&$sigs)
{
	foreach ($sigs as $parm => $descr) {
		$GLOBALS[$descr['varname']] = $_POST[$parm];
	}
}

//private $m_msg;

};
?>
