<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";
include_once "../conf/config.class.php";

class Action extends ActionBase
{
public $m_sigs = array (
			'dirname' => array (
					'req' => true, 
					'type' => 'string',
					'filter' => 'filename'
					),
	);

public function Run()
{
	global $gErrorMSG,$gMSG;
	global $gDB;

	$dirname = $_REQUEST['dirname'];

	// The Directory must exist:
	if (!is_dir($dirname)) {
		$gErrorMSG = "The Directory '$dirname' does not exist.";
		$this->DisplayContinueButton();
		return;
	}

	if (!$this->rm_recurse($dirname)) {
		$gErrorMSG = "The Directory '$dirname' could not be deleted.";
		$this->DisplayContinueButton();
		return;
	}

	$conf = new Config($gDB);
        try {
		$conf->DeleteConfDir($dirname);
        }
        catch (Exception $e) {
                $gErrorMSG = "Database error: ".$e->getMessage();
                return;
        }

	$gMSG = "Directory deleted and removed from Nagios Configuration";
	$this->DisplayContinueButton();
}

public function DisplayContinueButton()
{
	$this->Output("<div align=center>");
	$this->Output("<form action=index.php>");
	$this->Output("<input type=hidden name=action value=editfiles>");
	$this->Output("<input class=button type=submit name=submit value=Continue>");
	$this->Output("</form>");
	$this->Output("</div>");
}

private function rm_recurse($file) 
{
	if (is_dir($file) && !is_link($file)) {
		foreach(glob($file.'/*') as $sf) {
			if ( !$this->rm_recurse($sf) ) {
				error_log("Failed to remove $sf\n");
				return false;
			}
		}
		return rmdir($file);
	} 

	return unlink($file);
}

};
?>
