<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";
include_once "../conf/config.class.php";

class Action extends ActionBase
{
public $m_sigs = array (
			'filename' => array (
					'req' => true, 
					'type' => 'string',
					'filter' => 'filename'
					),
	);

public function Run()
{
	global $gErrorMSG,$gMSG;
	global $gDB;

	$filename = $_REQUEST['filename'];

	// The file must exist:
	if (!file_exists($filename)) {
		$gErrorMSG = "The file '$filename' does not exist.";
		$this->DisplayContinueButton();
		return;
	}

	if (!@unlink($filename)) {
		$gErrorMSG = "The file '$filename' could not be deleted.";
		$this->DisplayContinueButton();
		return;
	}

	$conf = new Config($gDB);
        try {
		$conf->DeleteConfFile($filename);
        }
        catch (Exception $e) {
                $gErrorMSG = "Database error: ".$e->getMessage();
                return;
        }

	$gMSG = "File deleted and removed from Nagios Configuration";
	$this->DisplayContinueButton();
}

public function DisplayContinueButton()
{
	$this->Output("<div align=center>");
	$this->Output("<form action=index.php>");
	$this->Output("<input type=hidden name=action value=editfiles>");
	$this->Output("<input class=button type=submit name=submit value=Continue>");
	$this->Output("</form>");
	$this->Output("</div>");
}

};
?>
