<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
		'__objtype' => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'addslashes'
			 	),
		'__objid'	  => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'onlydigit'
				),
	);

public function Run()
{
	global $gDB;
	global $gLogger;
	global $gMSG;
	global $gErrorMSG;
	
	$objtype = $_REQUEST['__objtype'];
	$objid   = $_REQUEST['__objid'];
	if (!ObjectFactory::IsValidObjectType($objtype)) {
		$gErrorMSG = "Internal Error: Object Type '$objtype' not supported !";
		return;
	}

	$ref = array();
	try {
		$obj = $gDB->BuildObject($objtype,$objid);
		$obj->GetReferences($gDB,$obj->GetAttr(),$ref);
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
	}
	
	try {
		if (count($ref) && $ref[0] != "not yet implemented") {
			$gErrorMSG = "This object is referenced by the following objects and cannot be deleted.";
			foreach ($ref as $item)
				$this->Output($item."<br>\n");
		}
		else {
			$gDB->Delete($objtype,$objid);
			$gMSG = "Operation successful !<br>";
		}
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
	}
	
	DisplayContinueButton($this,$objtype);
}

};
?>
