<?php
// $title: create or edit
// $act: Action object
// $objtype and $objid are the object descriptors
// $ze_obj: object with all the attributes and inherited ones
// $add_msg: additional messages to be displayed
function DisplayObject($title,$act,$objtype,$objid,$ze_obj,$add_msg,$showDetail = 1)
{
	global $gDB;

	$rownu = 0;
	
	$attrdef  = $ze_obj->GetDef();
	$attrlist = $ze_obj->GetAttr();
	$indexes  = $ze_obj->GetIndex();

	// Special case for template:
	$is_template = (isset($attrlist['name']) && $attrlist['name'] == "-->Fill here<--");

	// Display the header:
	$is_template = (isset($attrlist['register']) && $attrlist['register'] === "0") ? "Template" : "";

	// From v0.11: legend added here
	$legend = DisplayLegend();

	$detail = "";
	if ($ze_obj->HasDetails()) {
		$url = "index.php?";
		foreach ($_REQUEST as $key => $val) {
			$url .= "$key=$val&";
		}
		// From v0.10: Details links are displayed as buttons
		if ($showDetail) {
			//$detail = "<a href=\"$url"."detail=0\">Hide Detail</a>\n";
			$detail = "<input type=button class=button onClick=\"window.open('${url}detail=0','_self');\" value=\"Hide Details\">";
		}
		else {
			//$detail = "<a href=\"$url"."detail=1\">Show Detail</a>\n";
			$detail = "<input type=button class=button onClick=\"window.open('${url}detail=1','_self');\" value=\"Show Details\">";
		}
	}

	// Dump the object with the modification form:
	if ($objid == -1) {
		$act->Output("<form action=index.php?action=newobject method=post>\n");
	}
	else {
		$act->Output("<form action=index.php?action=applychanges method=post>\n");
	}
	$act->Output("<input type=hidden name=__objtype value='$objtype'>\n");
	$act->Output("<input type=hidden name=__objid value='$objid'>\n");
	$act->Output("<table>\n");
	
	$act->Output("<tr><td colspan=3><div class=title>$title $objtype $is_template</div></td><td colspan=1>$legend</td></tr><tr><td colspan=5><hr></td></tr>");
	
	DisplayButtons($detail,$act,$objid,$objtype);
	
	$mainkey  = (isset($indexes[0]) && isset($attrlist[$indexes[0]])) ? $attrlist[$indexes[0]] : "";

	foreach ($attrdef as $attr => $val) {
		$flag = isset($attrdef[$attr]['flag']) ?
				$flag = $attrdef[$attr]['flag'] : 0;
   
		if (isset($attrlist[$attr])) 
			$val = $attrlist[$attr];
		else
			$val = "";
			
		// Special case for template:
		if ($is_template) {
			$flag &= ~(OA::IS_MANDATORY|OA::IS_SEMIMAND);
			if ($attr == "name" || $attr == "__cfgfile") {
				$flag |= OA::IS_MANDATORY;
			}
		}
		else {
			// skip "name" attribute for non-template object:
			if ($attr == "name") continue;
		}

		if ($flag & OA::NOT_DISPLAYABLE) continue;

		# Changed from v0.8:
		# detail attributes are always displayed if they are mandatory:
		#if (!$showDetail && isset($attrdef[$attr]['detail']) && $attrdef[$attr]['detail']) continue;
		if (!$showDetail && isset($attrdef[$attr]['detail']) && $attrdef[$attr]['detail'] && !($flag & OA::IS_MANDATORY)) continue;
		
		$act->Output("<tr>");
		
		// Display attribute:
		if (($rownu % 2) == 0)
			$cellclass = "evenCell";
		else
			$cellclass = "oddCell";
			
		if ($attr == "name")
			$act->Output("<td class=$cellclass valign=top><b>$attr (for template)</b></td>");
		else
			$act->Output("<td class=$cellclass valign=top><b>$attr</b></td>");
		$rownu++;

		// Mandatory flag:
		if ($flag & OA::IS_MANDATORY) {
			$class = "mandatoryCell";
		}
		else if ($flag & OA::IS_SEMIMAND) {
			$class = "semimandatoryCell";
		}
		else {
			// For now, there's no more than 1 group of mandatory attr per object type:
			$grouped = false;
			$groups = $ze_obj->GetGroups();
			if (is_array($groups)) {
				foreach ($groups as $group) {
					foreach ($group as $gattr) {
						if ($attr == $gattr) {
							$grouped = true;
						}
					}
				}
			}
			if ($grouped)
				$class = "groupedCell";
			else
				$class = "optionalCell";
		}
		$act->Output("<td class=$class></td>");
				
		// In case, $val must be modified before being displayed
		$displayValue = $val;
		
		// Set the form component according to the attribute type:
		$act->Output("<td class=cell>");

		// Display additional messages:
		if (isset($add_msg[$attr]) && !empty($add_msg[$attr])) {
			//$act->Output("<tr><td></td><td></td><td colspan=2>");
			$act->Output("<div class=errorCell>".htmlspecialchars($add_msg[$attr])."</div>");
			//$act->Output("</td></tr>");
		}
		
		// Determine if value is inherited or not:
		$onchange = "";
		if ($isInherited = ($ze_obj->GetOrigin($attr) != "" && $ze_obj->IsInheritable($attr)))
			//$onchange = "onchange='var i=document.getElementById(\"overload_$attr\");i.checked=1;'";
			//echo "attr $attr is inherited from ".$ze_obj->GetOrigin($attr)."<br>";
			;
		$act->IsInherited($isInherited);
		$act->SetOnChange($onchange);
		$multiple_list = false;

		switch ($attrdef[$attr]['type']) {
		
		case OA::HOST_T:
			if ($objtype == "ServiceExtInfo") 
				$act->DisplaySingleListServiceExtInfo($attr,"Host",$displayValue);
			else
				$act->DisplaySingleList($attr,"Host",$displayValue);
			break;
			
		case OA::COMMENT_T:
			$act->DisplayComment($attr,$displayValue);
			break;
			
		case OA::CFGFILE_T:
			$act->DisplayConfigFile($attr,$displayValue);
			break;
			
		case OA::SYMBOL_T:
			$act->DisplaySymbol($attr,$displayValue);
			break;
					
		case OA::IPADDR_T:
			$act->DisplayIPAddr($attr,$displayValue);
			break;
					
		case OA::BOOL_T:
			$act->DisplayBool($attr,$displayValue);
			break;
			
		case OA::NUMERIC_T:
			$act->DisplayNumeric($attr,$displayValue);
			break;
			
		case OA::COORD2D_T:
			$act->Display2DCoord($attr,$displayValue);
			break;
			
		case OA::COORD3D_T:
			$act->Display3DCoord($attr,$displayValue);
			break;
	
		case OA::IMAGE_T:
			$act->DisplayImage($attr,$displayValue);
			break;
							
		case OA::SRVDESC_T:
			$act->DisplaySingleList($attr,"Service",$displayValue);
			break;
			
		case OA::CONTACTGRP_T:
			$act->DisplaySingleList($attr,"ContactGroup",$displayValue);
			break;

		case OA::TIMEPERIOD_T:
			$act->DisplaySingleList($attr,"TimePeriod",$displayValue);
			break;
		
		case OA::COMMAND_T:
			// Command looks like: check_ping!parm1!parm2....
			// Modified since v0.10: command are displayed with a helper function
			//$act->DisplayComment($attr,$displayValue);
			$act->DisplayCommand($attr,$displayValue);
			break;
			
		case OA::PERCENT_T:
			$act->DisplayPercent($attr,$displayValue);
			break;
			
		case OA::NOTIFOPT_T:
			$act->DisplayNotificationOptions($attr,$displayValue);
			break;
			
		case OA::HOSTNOTIFOPT_T:
			$act->DisplayHostNotificationOptions($attr,$displayValue);
			break;
			
		case OA::SRVNOTIFOPT_T:
			$act->DisplayServiceNotificationOptions($attr,$displayValue);
			break;
			
		case OA::HOSTSTALKOPT_T:
			$act->DisplayHostStalkOptions($attr,$displayValue);
			break;
			
		case OA::SRVSTALKOPT_T:
			$act->DisplayServiceStalkOptions($attr,$displayValue);
			break;
			
		case OA::ESCALHOSTOPT_T:
			$act->DisplayEscalationHostOptions($attr,$displayValue);
			break;
			
		case OA::ESCALSRVOPT_T:
			$act->DisplayEscalationServiceOptions($attr,$displayValue);
			break;
			
		case OA::HOSTLIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"Host",$displayValue);
			break;
			
		case OA::HOSTGRPLIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"HostGroup",$displayValue);
			break;
						
		case OA::SERVICELIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"Service",$displayValue);
			break;
		
		case OA::CONTACTLIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"Contact",$displayValue);
			break;	
			
		case OA::COMMANDLIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"Command",$displayValue);
			break;
			
		case OA::CONTACTGRPLIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"ContactGroup",$displayValue);
			$multiple_list = true;
			break;

		case OA::TIMEPERIODLIST_T:
			$act->DisplayMultipleList($objtype,$mainkey,$attr,"Timeperiod",$displayValue);
			break;

		case OA::TIMERANGELIST_T:
			$act->DisplayTimeRangeList($attr,$displayValue);
			break;
			
		case OA::HOSTSRVLIST_T:
			// TODO: it's hard to display the mixed list of host/service
			//       (see the syntax of members attribute in ServiceGroup)
			$act->DisplayComment($attr,$displayValue);
			break;
		
		case OA::HOSTTEMPL_T:
			$act->DisplayTemplateList($attr,"Host",$displayValue);
			break;
			
		case OA::HOSTGRPTEMPL_T:
			$act->DisplayTemplateList($attr,"HostGroup",$displayValue);
			break;
		
		case OA::HOSTESCTEMPL_T:
			$act->DisplayTemplateList($attr,"HostEscalation",$displayValue);
			break;
		
		case OA::HOSTDEPTEMPL_T:
			$act->DisplayTemplateList($attr,"HostDependency",$displayValue);
			break;
		
		case OA::SERVTEMPL_T:
			$act->DisplayTemplateList($attr,"Service",$displayValue);
			break;
		
		case OA::SRVGRPTEMPL_T:
			$act->DisplayTemplateList($attr,"ServiceGroup",$displayValue);
			break;
		
		case OA::SRVESCTEMPL_T:
			$act->DisplayTemplateList($attr,"ServiceEscalation",$displayValue);
			break;
		
		case OA::SRVDEPTEMPL_T:
			$act->DisplayTemplateList($attr,"ServiceDependency",$displayValue);
			break;
		
		case OA::CMDTEMPL_T:
			$act->DisplayTemplateList($attr,"Command",$displayValue);
			break;
		
		case OA::CONTACTTEMPL_T:
			$act->DisplayTemplateList($attr,"Contact",$displayValue);
			break;
		
		case OA::CONTGRPTEMPL_T:
			$act->DisplayTemplateList($attr,"ContactGroup",$displayValue);
			break;
		
		case OA::EXTHOSTTEMPL_T:
			$act->DisplayTemplateList($attr,"HostExtInfo",$displayValue);
			break;
		
		case OA::EXTSRVTEMPL_T:
			$act->DisplayTemplateList($attr,"ServiceExtInfo",$displayValue);
			break;
		
		case OA::TIMETEMPL_T:
			$act->DisplayTemplateList($attr,"Timeperiod",$displayValue);
			break;
			
		case OA::EXECHOSTFAIL_T:
			$act->DisplayHostFailureCriteria($attr,$displayValue);
			break;
			
		case OA::EXECSRVFAIL_T:
			$act->DisplayServiceFailureCriteria($attr,$displayValue);
			break;
			
		default: die("Unknown attribute type: ".$attrdef[$attr]['type']);
		};
				
		if (isset($attrdef[$attr]['default'])) {
			$act->Output("(default value: ".htmlspecialchars($attrdef[$attr]['default']).")");
		}

		// From v0.10: display the expected unit:
		if (isset($attrdef[$attr]['unit'])) {
			$act->Output("[".$attrdef[$attr]['unit']."]");
		}
		
		$act->Output("</td>\n");
			
		// show the origin of the value: inherited or local
		// overloaded values can be unset so the object take the inherited value:
		if ($isInherited) {
			$act->Output("<td class=cell colspan=2>");
			$act->Output("<input type=hidden name='inherited_$attr' value=1>");
			//if ($multiple_list)
			//	$act->Output("<input type=checkbox id='overload_$attr' name='overload_$attr' onClick='fieldOverload(\"${attr}[]\");'> Overload ");
			//else
				$act->Output("<input type=checkbox id='overload_$attr' name='overload_$attr' onClick='fieldOverload(\"$attr\");'> Overload ");
			$act->Output("inherited value from <i>".$ze_obj->GetOrigin($attr)."</i>&nbsp;");
			$act->Output("</td>");
			}
		// Modified from v0.5: one can unset values which CAN BE inherited
		/*
		else if (!($flag & OA::IS_MANDATORY)) {
			$act->Output("<td class=cell colspan=2>");
			if ($displayValue != "" || $displayValue === "0")
				$act->Output("<input type=checkbox name='unset_$attr'> Unset");
			$act->Output("</td>");
		}
		*/
		else if (($inh = $ze_obj->IsInheritable($attr)) != "") {
			try {
				$parent = $gDB->BuildObjectFromName($objtype,$inh);
			}
			catch (Exception $e) {
				$gErrorMSG = "Internal Error: ".$e->getMessage();
				return;
			}

			// Check if parent attribute is set or not:
			$parentattr = $parent->GetAttr();
			$act->Output("<td class=cell colspan=2>");
			if ($parentattr[$attr] != "") {
				//echo "attr=$attr, value=".$parentattr[$attr]."|<br>";
				if ($displayValue != "" || $displayValue === "0") {
					$act->Output("<input type=checkbox id='unset_$attr' name='unset_$attr' onClick='fieldUnset(\"$attr\");'> Revert to value from <i>$inh</i>");
				}
			}
			$act->Output("</td>");
		}
		else {
			$act->Output("<td colspan=2 class=cell></td>");
		}
					
		$act->Output("</tr>\n");
	}
	
	// From v1.0: display custom atributes:
	foreach ($attrlist as $attr => $value) {
		if (NagiosObject::IsCustomAttr($attr)) {
			if (($rownu % 2) == 0)
				$cellclass = "evenCell";
			else
				$cellclass = "oddCell";
			
			$act->Output("<tr><td class=$cellclass valign=top><b>$attr</b></td>");
			$act->Output("<td class=customcell></td>");
			$act->Output("<td class=cell><input class=formItem type=text name='$attr' value='$value' size=30></td>");
			$act->Output("<td colspan=2 class=cell><input class=formItem type=checkbox name='del_$attr'> Delete</td></tr>");
			$rownu++;
		}
	}
	// Display a special line to create new custom attributes:
	if (($rownu % 2) == 0)
		$cellclass = "evenCell";
	else
		$cellclass = "oddCell";
	$act->Output("<tr><td class=$cellclass valign=top></td>");
	$act->Output("<td class=customcell></td>");
	$act->Output("<td class=cell>Name: <input class=formItem type=text name='new_custattr' value='' size=30>&nbsp;value: <input class=formItem type=text name='new_custvalue' value='' size=30>");
	$act->Output("</td>");
	$act->Output("<td colspan=2 class=cell><input class=button type=submit name='but_custattr' value='Create New Custom Attribute'></td></tr>");

	DisplayButtons($detail,$act,$objid,$objtype);
	
	$act->Output("</table>\n");
	$act->Output("</form>\n");
}

function DisplayButtons($detail,$act,$objid,$objtype)
{
	// From v0.10: also display buttons that link to the documentation
	//$act->Output("<tr><td>$detail</td><td></td><td colspan=2 align=left>");
	$act->Output("<tr><td>$detail</td><td></td><td align=left>");
	
	if ($objid == -1) {
		$act->Output("<input class=button type=submit name=Create value='Create'> ");
		$act->Output("<input class=button type=submit name=Discard value='Discard'> ");
	}
	else {
		$act->Output("<input class=button type=submit name=Apply value='Apply Changes'> ");
		$act->Output("<input class=button type=submit name=Discard value='Discard Changes'> ");
		// From v1.0.1: this button wa not implemented and has been removed
		//$act->Output("<input class=button type=submit name=Delete value='Delete' onClick=\"javascript:return ConfirmDelete()\">");
	}
	
	// From v0.10: Help buttons:
	$objtype = strtolower($objtype);
	// new look from v1.0.1
	//$act->Output("</td><td align=right><input type=submit class=button name=Help value=Help onClick=\"doc=window.open('/nagios/docs/objectdefinitions.html#$objtype','Documentation','menubar=yes,scrollbars=yes,width=650,height=500'); doc.focus(); return false;\">");
	$act->Output("</td><td align=right><input type=submit class=button name=Help value=Help onClick=\"var win = new Window({className: 'mac_os_x', title: 'Documentation', top:70, left:100, width:650, height:500, url: '/nagios/docs/objectdefinitions.html#$objtype', showEffectOptions: {duration:1.5}}); win.show(); return false;\">");

	$act->Output("</td></tr>\n");
}	

function DisplayContinueButton($act,$objtype)
{
	$act->Output("<div align=center>");
	$act->Output("<form action=index.php>");
	$act->Output("<input type=hidden name=action value=editobjlist>");
	$act->Output("<input type=hidden name=__objtype value=$objtype>");
	$act->Output("<input class=button type=submit name=submit value=Continue>");
	$act->Output("</form>");
	$act->Output("</div>");
}

function ConsolidateValues(&$attrvalues,$attr,$chars)
{
	// Handle 2D and 3D coords:
	if ($chars['type'] == OA::COORD2D_T) {
		if (!isset($attrvalues[$attr."_x"]) ||
		    !isset($attrvalues[$attr."_y"]))
		    	return;
			
		$attrvalues[$attr] = $attrvalues[$attr."_x"].",".$attrvalues[$attr."_y"];
		if ($attrvalues[$attr] == ",") $attrvalues[$attr] = "";
	}
	else if ($chars['type'] == OA::COORD3D_T) {
		if (!isset($attrvalues[$attr."_x"]) ||
		    !isset($attrvalues[$attr."_y"]) ||
		    !isset($attrvalues[$attr."_z"]))
		    	return;
			
		$attrvalues[$attr] = $attrvalues[$attr."_x"].",".$attrvalues[$attr."_y"].",".$attrvalues[$attr."_z"];
		if ($attrvalues[$attr] == ",,") $attrvalues[$attr] = "";
	}
					
	if (!isset($attrvalues[$attr]))
		return;
		
	// linearize arrays:
	if (is_array($attrvalues[$attr])) 
		$attravlues[$attr] = implode(",",$attrvalues[$attr]);
}

// From v0.11: display a legend for the attribute colors:
function DisplayLegend()
{
	$legend  = "<td align=right><span class=stdtext>Attribute Legend : ";
	$legend .= "<span class=optionalCell>optional</span>&nbsp;";
	$legend .= "<span class=semimandatoryCell>grouped</span>&nbsp;";
	$legend .= "<span class=mandatoryCell>mandatory</span>&nbsp;";
	$legend .= "<span class=customCell>custom</span>&nbsp;";
	$legend .= "</span></td>";

	return $legend;
}
?>
