<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
	);

public function Run()
{
	global $gMSG;
	global $gDB;

	// Process each resource file:
	try {
		$dirlist  = $gDB->GetMainDirList();
		$filelist = $gDB->GetMainFileList();
	}
	catch (Exception $e) {
		$gMSG = "Database error: ".$e->getMessage();
		return;
	}

	// Test if the directory belongs to another Configuration Directory:
	$conf = new Config($gDB);

	// Display the header:
	$this->Output("<div class=title>Configuration File and Directory Management</div><hr>");
	
	// Display the Directory list:
	$this->Output("<table width=450><tr>");
	$this->Output("<td valign=center><span class=listhdr>Current Directory List:</span></td>");
	$this->Output("</tr></table>");
	if (!is_array($dirlist) || count($dirlist) == 0) {
		$this->Output("<p class=evenCell>(empty)</p>");
	}
	else {
		$this->Output("<table>\n");
		$this->Output("<tr class=rowhdr><th>Remove from<br>configuration</th><th>Delete<br>from Disk</th><th>Name</th></tr>");
		$objnu = 0;

		foreach ($dirlist as $dir) {
			if (($objnu % 2) == 0)		
				$cellclass = "evenCell";
			else 
				$cellclass = "oddCell";
			$objnu++;
			
			$this->Output("<tr class=$cellclass>");
				
			$this->Output("<td>");
			$this->Output("<a href=index.php?action=removedir&dirname=\"${dir['dirname']}\">Remove</a>");
			$this->Output("</td>");

			$this->Output("<td>");
			$this->Output("<a href=index.php?action=deletedir&dirname=\"${dir['dirname']}\" onclick=\"javascript:return ConfirmDelete('index.php?action=deletedir&dirname=\\'${dir['dirname']}\\'');\">Delete</a>");
			$this->Output("</td>");
				
			$this->Output("<td>");
			$this->Output("${dir['dirname']}");
			$this->Output("</td>");
				
			$this->Output("</tr>\n");

			$objnu++;
		}
		
		$this->Output("</table>\n");
	}

	// Display the "New" button:
	$this->Output("<table><tr>\n");
	$this->Output("<td valign=center class=stdtext><form action=index.php method=get>");
	$this->Output("<form action=index.php method=get>");
	$this->Output("<input type=hidden name=action value=newconfdir>");
	$this->Output("Directory Name : <input class=formItem type=text size=40 name=dirname>&nbsp;&nbsp;");
	$this->Output("<input class=button type=submit name=New value='Add Directory'>");
	$this->Output("</form></td>\n");
	$this->Output("</tr></table>");
		
	// Display the File list:
	$this->Output("<table width=450><tr>");
	$this->Output("<td valign=center><span class=listhdr>Current File List:</span></td>");
	$this->Output("</tr></table>");
		
	if (!is_array($filelist) || count($filelist) == 0) {
		$this->Output("<p class=evenCell>(empty)</p>");
	}
	else {
		$this->Output("<table>\n");
		$this->Output("<tr class=rowhdr><th>Remove from<br>configuration</th><th>Delete<br>from Disk</th><th>Name</th><th>Object<br>Count</th></tr>");
		$objnu = 0;

		foreach ($filelist as $file) {
			if (($objnu % 2) == 0)		
				$cellclass = "evenCell";
			else 
				$cellclass = "oddCell";
			$objnu++;
			
			$this->Output("<tr class=$cellclass>");
				
			$this->Output("<td>");

			if ($conf->IsUnderConfDir($file['filename']))
				$this->Output("Belongs to a Dir");
			else
				$this->Output("<a href=index.php?action=removefile&filename=\"${file['filename']}\">Remove</a>");

			$this->Output("</td>");

			$this->Output("<td>");
			$this->Output("<a href=index.php?action=deletefile&filename=\"${file['filename']}\" onclick=\"javascript:return ConfirmDelete('index.php?action=deletefile&filename=\\'${file['filename']}\\'');\">Delete</a>");
			$this->Output("</td>");
				
			$this->Output("<td>");
			$this->Output("${file['filename']}");
			$this->Output("</td>");
				
			$this->Output("<td align=center>");
			$count = $conf->CountOfObjectInFile($file['filename']);
			$this->Output("$count</td>");

			$this->Output("</tr>\n");

			$objnu++;
		}
		
		$this->Output("</table>\n");
	}

	// Display the "New" button:
	$this->Output("<table><tr>");
	$this->Output("<td valign=center class=stdtext><form action=index.php method=get>");
	$this->Output("<input type=hidden name=action value=newconffile>&nbsp;&nbsp;");
	$this->Output("File Name : <input class=formItem type=text size=40 name=filename>&nbsp;&nbsp;");
	$this->Output("<input class=button type=submit name=New value='Add File'>");
	$this->Output("</form></td>\n");
	$this->Output("</tr></table>");
	
}

};
?>
