<?php
include_once "actionbase.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
		'__objtype' => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'addslashes'
			 	),
	);

public function Run()
{
	global $gDB;
	global $gErrorMSG;
	global $gShowInheritedUsage;
	global $gShowReferenceUsage;
	
	$objtype = $_REQUEST['__objtype'];
	if (!ObjectFactory::IsValidObjectType($objtype)) {
		$gErrorMSG = "Internal Error: Object Type '$objtype' not supported !";
		return;
	}
	
	try {
		$objlist = $gDB->GetObjectOfType($objtype);
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return;
	}
	
	// Display the header:
	$this->Output("<div class=title>$objtype Management</div>");
	if ($objtype == "HostExtInfo" || $objtype == "ServiceExtInfo")
		$this->Output("Nagios v3 recommends these attributes should be stored in the Host or Service definitions");
	$this->Output("<hr>");
	
	// Display the object list:
	$this->Output("<table width=450><tr>");
	$this->Output("<td valign=center><span class=listhdr>Current $objtype List:</span></td>");
		
	// Display the "New" button:
	$this->Output("<td valign=center><form action=index.php method=get>");
	#$this->Output("<input type=hidden name=action value=emptyobject>");
	$this->Output("<input type=hidden name=action value=selecttemplate>");
	$this->Output("<input type=hidden name=__objtype value=$objtype>");
	$this->Output("<input class=button type=submit name=New value='New $objtype'>");
	$this->Output("</form></td>\n");
	$this->Output("</tr></table>");
	
	if (!is_array($objlist) || count($objlist) == 0) {
		$this->Output("<p class=evenCell>(empty)</p>");
		return;
	}
	
	// Get the index name:
	$obj = ObjectFactory::Factory($objtype);
	$indexes = $obj->GetIndex();

	assert(is_array($indexes));
	if (count($indexes) == 0) {
		die("Internal Error: no INDEX found for Object Type '$objtype'");
	}
		
	// foreach object, if the index attribute is empty,
	// we display the 'name' attribute if 'register' is 0: this
	// is a template. Otherwise this is an error.
	$this->Output("<table>\n");
		
	$this->Output("<tr class=rowhdr><th>Edit</th><th>Delete</th><th colspan=".count($indexes).">Name</th><th>Inheritage</th><th>References</th>");
	if ($objtype == "ContactGroup" || $objtype == "Contact") $this->Output("<th>Managed Objects</th>"); else $this->Output("<th></th>");
	$this->Output("</tr>");
	
	$objnu = 0;
	
	foreach ($objlist as $obj) {
		if (($objnu % 2) == 0)		
			$cellclass = "evenCell";
		else 
			$cellclass = "oddCell";
		$objnu++;
			
		//$obj = $gDB->BuildObject(); // if necessary
		$objid = $obj['__objid'];
		//print_r($obj);			
		
		$curobj = $gDB->BuildObject($objtype,$objid);

		$inheritlist = array();
		//$is_template = empty($obj[$index[0]]); // ugly
		$is_template = $curobj->IsTemplate();
		if ($is_template && $gShowInheritedUsage) {
			try {
				$inheritlist = $gDB->GetInheritedUsage($objtype,$obj['name']);
			}
			catch (Exception $e) {
				$gMSG = "Internal Error: ".$e->getMessage();
			}
		}
		
		$refcount = 0;
		$ref = array();
		if (!$is_template && $gShowReferenceUsage) {
			try {
				$curobj->GetReferences($gDB,$curobj->GetAttr(),$ref);
				$refcount = count($ref);
			}
			catch (Exception $e) {
				$gMSG = "Internal Error: ".$e->getMessage();
			}
		}
			
		$this->Output("<tr class=$cellclass><td>");			
		$this->Output("<a href=index.php?action=editobject&__objtype=$objtype&__objid=$objid>Edit</a>");
		$this->Output("</td>");
			
		$this->Output("<td>");
		if ((count($inheritlist) == 0 && $refcount == 0) || (count($ref) > 0 && $ref[0] == "not yet implemented")) {
			$this->Output("<a href=index.php?action=deleteobject&__objtype=$objtype&__objid=$objid onclick=\"javascript:return ConfirmDelete('index.php?action=deleteobject&__objtype=$objtype&__objid=$objid');\">Delete</a>");
		}
		else {
			$this->Output("in use");
		}
		$this->Output("</td>");
			
		if ($is_template) {
			$this->Output("<td colspan=".count($indexes).">");
			$this->Output($obj['name']." (template)");
			$this->Output("</td>");
		}
		else {
			// a comma delimiter has been added since v0.10
			$first = 1;
			foreach ($indexes as $index) {
				$this->Output("<td>");	
				
				// From v1.0.1: nicer output for multiple values:
				if (1) {
					$parts = explode(",",$obj[$index]);
					foreach ($parts as $part) $this->Output("$part<br>");
				}
				else {
					$this->Output($obj[$index]);
				}

				// hack from v0.10 for service
				/*
				if ($objtype == "Service" && $first == 1 && $obj['hostgroup_name']){
					if ($obj['host_name']) $this->Output(",");
					$this->Output($obj['hostgroup_name']);
				}
				$first = 0;
				*/

				$this->Output("</td>");
			}
		}
		
		$this->Output("<td>");
		if (!$is_template) {
			if (isset($obj['use']) && !empty($obj['use']))
				$this->Output("uses ".$obj['use']);
		}	
		$this->Output("</td>");
		
		$this->Output("<td>");
		if ($is_template) {
			if ($gShowInheritedUsage) {
				$this->Output("Used ".count($inheritlist));
				if (count($inheritlist) > 1)
					$this->Output(" times");
				else
					$this->Output(" time");
			}
		}
		else if ($gShowReferenceUsage) {
			if ($refcount) {
				if ($refcount == 1) {
					if ($ref[0] != "not yet implemented") {
						$this->Output("Referenced $refcount time");
					}
					else {
						$this->Output($ref[0]);
						$ref = array();
					}
				}
				else {
					$this->Output("Referenced $refcount times");
				}
					
				foreach ($ref as $r) {
					$this->Output("<br>$r\n");
				}
			}
		}
		$this->Output("</td>");

		if (!$is_template && ($objtype == "ContactGroup" || $objtype == "Contact")) {
			$this->Output("<td>not yet implemented</td>");
			# TODO: debug this call
			#$this->Output("<td align=center><a href=\"index.php?action=showcontactobject&__objid=$objid&__objtype=$objtype\">Show</a></td>");
			//$this->Output("&nbsp;<input type=button class=button onClick=\"chooser=window.open('/eznag/index.php?action=viewplugins&__nomenu=1','CommandList','menubar=no,scrollbars=yes,toolbar=no,width=550,height=440');\" value=\"View Plugins\">");
		}
		else {
			$this->Output("<td></td>");
		}
			
		$this->Output("</tr>\n");
	}
		
	$this->Output("</table>\n");
}

};
?>
