<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";
include_once "../conf/config.class.php";

class Action extends ActionBase
{
public $m_sigs = array (
			'dirname' => array (
					'req' => true, 
					'type' => 'string',
					'filter' => 'filename'
					),
	);

public function Run()
{
	global $gErrorMSG,$gMSG;
	global $gDB;

	// Could not use realpath() since it does not work on non-existing files !
	#$dirname = realpath($_REQUEST['dirname']);
	$dirname = $_REQUEST['dirname'];

	// The Directory must not be already listed:
	try {
		$dirlist = $gDB->GetMainDirList();
	}
	catch (Exception $e) {
		$gErrorMSG = "Database error: ".$e->getMessage();
		$this->DisplayContinueButton();
		return;
	}
	foreach ($dirlist as $dir) {
		if ($dirname == $dir['dirname']) {
			$gErrorMSG = "Directory already referenced in Nagios Configuration";
			$this->DisplayContinueButton();
			return;
		}
	}

	// Test if the directory belongs to another Configuration Directory:
	$conf = new Config($gDB);
	$is_under_dir = $conf->IsUnderConfDir($dirname);

	// Test if the Directory exists:
	if (!is_dir($dirname)) {
		// Try to create an empty Directory:
		if (!mkdir($dirname,0755,true)) {
			$gErrorMSG = "Could not create the Directory '$dirname'";
			$this->DisplayContinueButton();
			return;
		}
	}

	// Does the Directory belong to a cfg_dir Directory ?
	// if yes: nothing to do in the configuration
	// if not: we must update the configuration in nagios.cfg

	if (!$is_under_dir) {
		try {
			$conf->AddConfDir($dirname);
		}
		catch (Exception $e) {
			$gErrorMSG = "Database error: ".$e->getMessage();
			rmdir($dirname);
			try {
				$conf->DeleteConfDir($dirname);
			}
			catch (Exception $e) {
			}
			$this->DisplayContinueButton();
			return;
		}

		$gMSG = "New Directory added in Nagios Configuration";
	}
	else {
		$gMSG = "This Directory is located under a Directory which is already part of Nagios Configuration";
	}

	$this->DisplayContinueButton();
}

public function DisplayContinueButton()
{
	$this->Output("<div align=center>");
	$this->Output("<form action=index.php>");
	$this->Output("<input type=hidden name=action value=editfiles>");
	$this->Output("<input class=button type=submit name=submit value=Continue>");
	$this->Output("</form>");
	$this->Output("</div>");
}

};
?>
