<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";
include_once "../conf/config.class.php";

class Action extends ActionBase
{
public $m_sigs = array (
			'filename' => array (
					'req' => true, 
					'type' => 'string',
					'filter' => 'filename'
					),
	);

public function Run()
{
	global $gErrorMSG,$gMSG;
	global $gDB;

	// Could not use realpath() since it does not work on non-existing files !
	#$filename = realpath($_REQUEST['filename']);
	$filename = $_REQUEST['filename'];

	// The file must not be already listed:
	try {
		$filelist = $gDB->GetConfigFileList();
	}
	catch (Exception $e) {
		$gErrorMSG = "Database error: ".$e->getMessage();
		$this->DisplayContinueButton();
		return;
	}
	foreach ($filelist as $file) {
		if ($filename == $file['filename']) {
			$gErrorMSG = "File already referenced in Nagios Configuration";
			$this->DisplayContinueButton();
			return;
		}
	}

	// Test if the file belongs to a Configuration Directory:
	try {
		$dirlist = $gDB->GetMainDirList();
	}
	catch (Exception $e) {
		$gErrorMSG = "Database error: ".$e->getMessage();
		$this->DisplayContinueButton();
		return;
	}

	$conf = new Config($gDB);
	$is_under_dir = $conf->IsUnderConfDir($filename);

	// Test if the file must exist:
	if (!file_exists($filename)) {
		// Try to create an empty file:
		if (($fd = fopen($filename,"w")) === FALSE) {
			$gErrorMSG = "Could not create file '$filename'";
			$this->DisplayContinueButton();
			return;
		}
		fclose($fd);
	}

	// Does the file belong to a cfg_dir Directory ?
	// if yes: nothing to do in the configuration
	// if not: we must update the configuration in nagios.cfg

	if (!$is_under_dir) {
		$conf = new Config($gDB);
		try {
			$conf->AddConfFile($filename);
		}
		catch (Exception $e) {
			$gErrorMSG = "Database error: ".$e->getMessage();
			unlink($filename);
			try {
				$conf->DeleteConfFile($filename);
			}
			catch (Exception $e) {
			}
			$this->DisplayContinueButton();
			return;
		}

		$gMSG = "New File added in Nagios Configuration";
	}
	else {
		$gMSG = "New File created.<br>This file is located under a Directory which is already part of Nagios Configuration";
	}

	$this->DisplayContinueButton();
}

public function DisplayContinueButton()
{
	$this->Output("<div align=center>");
	$this->Output("<form action=index.php>");
	$this->Output("<input type=hidden name=action value=editfiles>");
	$this->Output("<input class=button type=submit name=submit value=Continue>");
	$this->Output("</form>");
	$this->Output("</div>");
}

};
?>
