<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";
include_once "rrdgraph.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
		'__objtype' => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'addslashes'
			 	),
		'__cfgfile' => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'filename'
			 	),
		'Discard' => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'addslashes'
			 	),
		'detail'	  => array (
				'req' => false, 
				'type' => 'boolean',
				'filter' => 'boolean'
				),
	);

public function Run()
{
	global $gDB;
	global $gMSG;
	global $gErrorMSG;
	global $gShowDetail;
	
	$showDetail = isset($_REQUEST['detail']) ? $_REQUEST['detail'] : $gShowDetail;
	$objtype = $_REQUEST['__objtype'];
	if (!ObjectFactory::IsValidObjectType($objtype)) {
		$gErrorMSG = "Internal Error: Object Type '$objtype' not supported !";
		return;
	}

	if (isset($_REQUEST['Discard']) && $_REQUEST['Discard']) {
		$gMSG = "$objtype Creation discarded";
		DisplayContinueButton($this,$objtype);
		return;
	}
	
	// Added on the 04 Apr 2008 (v0.11) to take care of magic_quotes_gpc
	$this->NormalizeValues($_POST);

	//phpinfo();
	// Check the modification consistency:	
	$newobj = ObjectFactory::Factory($objtype);
	$newobj->SetContext(isset($_REQUEST['__cfgfile'])?$_REQUEST['__cfgfile']:"");
	$has_error = $newobj->CheckAttributes($gDB,$_POST,$add_msg,"new");
	
	// Set the form fields to the newly created object:
	$attrdef = $newobj->GetDef();
	foreach ($attrdef as $attr => $chars) {
		ConsolidateValues($_POST,$attr,$chars);

		if (!isset($_POST[$attr])) continue;

		// Fixed with v0.5+
		// Values are set if they are not inherited:
		#if ($newobj->IsInheritable($attr)) {
		#	if (!isset($_POST['overload_$attr'])) {
		#		$newobj->UnsetAttr($attr);
		#		continue;
		#	}
			// Eliminate values which are the same as the inherited ones:
			if (isset($_POST["inherited_$attr"]) && !isset($_POST["overload_$attr"])) {
				$newobj->UnsetAttr($attr);
				continue;
			}
		#}

		$newobj->AddAttr($attr,$_POST[$attr]);
	}
	
	if ($has_error) { 
		if ($has_error > 1)
			$gErrorMSG = "Invalid values make the Creation impossible !"; 
		else	
			$gErrorMSG = "Invalid value makes the Creation impossible !"; 

		// added from v0.5, otherwise inheritance labels were missing in case of errors
		$gDB->BuildObjectInherited($newobj);

		DisplayObject("New",$this,$objtype,-1,$newobj,$add_msg,$showDetail);
		return;
	}
	
	// Get a new ID:
	try {
		$objid = $gDB->GetMaxObjID();
		$newobj->AddAttr("__objid",$objid);
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return;
	}
	
	try {
		$comments = array();
		$comments[] = "# Created by eznag!\n";
		$gDB->Store($newobj,$objid,$comments,$objid); 
		$gMSG = "Operation successful !<br>";

		# update the service extended info if RRDTool enabled
		RRDToolSynchronize($newobj);
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
	}
	
	DisplayContinueButton($this,$objtype);
}

};
?>
