<?php
#
# Configuration for nmap and object creation:
#

# Localisation of nmap tool (leave nmap if located in the PATH):
$gNmapCommand = "/usr/bin/nmap";	// will be called by sudo

# Default configuration for host creation:
#$host_use_dflt = "generic-host";
$host_use_dflt = "linux-server";
$host_check_command_dflt = "check-host-alive";
$host_contact_groups_dflt = "admins";
$host_max_check_attempts_dflt = 3;
$host_check_period_dflt = "24x7";
$host_notification_interval_dflt = 5;
$host_notification_period_dflt = "24x7";
$host_notification_options_dflt = "d,u,r";
$host_active_checks_enabled = "1";
$host_notifications_enabled = "1";

# Default configuration for service creation:
#$service_use_dflt = "generic-service";
$service_use_dflt = "local-service";
$service_is_volatile_dflt = "0";
$service_check_period_dflt = "24x7";
$service_max_check_attempts_dflt = 3;
$service_normal_check_interval_dflt = 5;
$service_retry_check_interval_dflt = 1;
$service_contact_groups_dflt = "admins";
$service_notification_interval_dflt = 5;
$service_notification_period_dflt = "24x7";
$service_notification_options_dflt = "c,r";
$service_notifications_enabled = "1";
$service_passive_checks_enabled = "1";
$service_active_checks_enabled = "1";

# Name of temporary files:
$nmap_lock_file = "/tmp/eznag_nmap.running";
$nmap_tcp_result = "/tmp/eznag_nmap.tcp";
$nmap_udp_result = "/tmp/eznag_nmap.udp";

# Array which give the service description according to the port number.
# Also gives the associated check_command:
$tcp_desc = array (
	# to be completed
	21 => array (
			'desc' => 'FTP',
			'cmd'  => 'check_ftp'
		),
	22 => array (
			'desc' => 'SSH',
			'cmd'  => 'check_ssh'
		),
	23 => array (
			'desc' => 'Telnet',
			'cmd'  => 'check_telnet'
		),
	25 => array (
			'desc' => 'SMTP',
			'cmd'  => 'check_smtp'
		),
	53 => array (
			'desc' => 'DNS',
			'cmd'  => 'check_dns'
		),
	80 => array (
			'desc' => 'HTTP',
			'cmd'  => 'check_http'
		),
	110 => array (
			'desc' => 'POP',
			'cmd'  => 'check_pop'
		),
	143 => array (
			'desc' => 'IMAP',
			'cmd'  => 'check_imap'
		),
	389 => array (
			'desc' => 'LDAP',
			'cmd'  => 'check_ldap'
		),
	465 => array (
			'desc' => 'SSMTP',
			'cmd'  => 'check_ssmtp'
		),
	636 => array (
			'desc' => 'LDAPS',
			'cmd'  => 'check_ldaps'
		),
	994 => array (
			'desc' => 'IMAPS',
			'cmd'  => 'check_simap'
		),
	995 => array (
			'desc' => 'POPS',
			'cmd'  => 'check_spop'
		),
	110 => array (
			'desc' => 'POP',
			'cmd'  => 'check_pop'
		),
	1521 => array (
			'desc' => 'SQL*NET',
			'cmd'  => 'check_oracle'
		),
	3306 => array (
			'desc' => 'MySQL',
			'cmd'  => 'check_mysql'
		),
	5432 => array (
			'desc' => 'POSTRGESQL',
			'cmd'  => 'check_pgsql'
		),
);

$udp_desc = array (
	# to be completed
	53 => array (
			'desc' => 'DNS',
			'cmd'  => 'check_dns'
		),
	67 => array (
			'desc' => 'DHCP',
			'cmd'  => 'check_dhcp'
		),
	389 => array (
			'desc' => 'LDAP',
			'cmd'  => 'check_ldap'
		),
	636 => array (
			'desc' => 'LDAPS',
			'cmd'  => 'check_ldaps'
		),
);
?>
