<?php
#
# Run nmap and parse the XML Output.
# Returns a HTML page with the detected host and service list.
#
# Note: apache must have the sudo right for nmap !
#
include_once "actionbase.inc.php";
include_once "nmap.inc.php";

// Variable used by the XML callback functions:
$gHosts = array();
$curaddr = "";
$curproto = "";
$cuport = "";
$curname = "";
$insideHost = false;

class Action extends ActionBase
{
public $m_sigs = array(
		'getresult'  => array (
				'req' => false, 
				'type' => 'boolean',
				),
		'create'  => array (
				'req' => false, 
				'type' => 'boolean',
				),
		'tcpport'  => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'nmapstring'
				),
		'udpport'  => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'nmapstring'
				),
		'netaddr'  => array (
				'req' => false, 
				'type' => 'string',
				'filter' => 'nmapstring'
				),
	);

public function Run()
{
	global $gHosts;
	global $tcp_desc;
	global $udp_desc;
	global $gDB;
	
	# Do we have to run nmap ?
	if (isset($_REQUEST['getresult']) && $_REQUEST['getresult'] == 'true') {
		$this->ParseResults();
	}
	
	$this->Output('<script type="text/javascript" src="js/AjaxRequest.js"></script>');
	$this->Output('<script type="text/javascript" src="js/nmap.js"></script>');

	$this->Output("<div class=title>Nmap Interface</div><hr>");
	$this->Output("<form method=post enctype='multipart/form-data' onSubmit=\"javascript:return launchnmap();\">\n");

	$this->Output('<table cellpadding="3" border="0">');
	$this->Output('<tr>');
	$this->Output('  <td colspan="2" align="left">');
  	$this->Output('<input class=button type="submit" value="Run nmap" name="runnmap">');
  	$this->Output('</td>');
	$this->Output('<td class="cell">Nmap Status : <input type=text name=nmapstatus value="" readonly></td>');
	$this->Output("</tr>\n");
	$this->Output('<tr>');
  	$this->Output('<td class="evenCell">Network</td>');
  	$this->Output('<td class="mandatoryCell" with="3">&nbsp;</td>');
	
	if (isset($_POST['netaddr'])) $netaddr = $_POST['netaddr']; 
	else $netaddr = '192.168.1.0/24';
  	$this->Output('<td class="cell"><input class=formItem type=text size=20 value="'.$netaddr.'" name=netaddr> use the CIDR notation (192.168.1.0/24)</td>');
	$this->Output('</tr>');
	$this->Output('<tr>');
  	$this->Output('<td class="oddCell">TCP Ports <input type=checkbox name=tcp value=""></td>');
  	$this->Output('<td class="mandatoryCell" with="3">&nbsp;</td>');
	
	if (isset($_POST['tcpport'])) $tcpport = $_POST['tcpport'];
	else $tcpport = "1-1024,3306,6000";
  	$this->Output('<td class="cell"><input class=formItem type=text size=20 value="'.$tcpport.'" name=tcpport> give a comma separated list or intervals</td>');
	$this->Output('</tr>');
	$this->Output('<tr>');
  	$this->Output('<td class="evenCell">UDP Ports <input type=checkbox name=udp value=""></td>');
  	$this->Output('<td class="mandatoryCell" with="3">&nbsp;</td>');
	
	if (isset($_POST['udpport'])) $udpport = $_POST['udpport'];
	else $udpport = "1-1024,3306,6000";
  	$this->Output('<td class="cell"><input class=formItem type=text size=20 value="'.$udpport.'" name=udpport> give a comma separated list or intervals</td>');
	$this->Output('</tr>');
	$this->Output('</table>');
	$this->Output('</form>');
	$this->Output("<form method=post enctype='multipart/form-data'>\n");
	$this->Output('<table cellpadding="3" border="0">');
	$this->Output('<tr>');
  	$this->Output('<td colspan="3" align="left">');
  	$this->Output('<input class=button type="submit" value="Import" name="xmlimport">');
  	$this->Output('</td>');
	$this->Output('</tr>');
	$this->Output('<tr>');
  	$this->Output('<td class="evenCell">XML File to upload</td>');
  	$this->Output('<td class="mandatoryCell" with="3">&nbsp;</td>');
  	$this->Output('<td class="cell"><input class=formItem type=file size=30 name="importfile[]"></td>');
	$this->Output('</tr>');

	# Do we have to import an XML file ?
	if (isset($_POST['xmlimport'])) {
		$file = $_FILES['importfile']['tmp_name'];
		$this->ParseResult($file[0]);
	}

	# Do we have to create new hosts and services ?
	if (isset($_POST['create'])) {
		$this->CreateNewObjects();
		$this->Output(implode("<br>\n",$this->m_report));
	}

	# $gHosts is set if nmap run and found some hosts:
	if (count($gHosts)) {
		$somethingToCreate = false;
	
		$this->Output('<tr><td colspan=3>&nbsp;</td></tr>');
		$this->Output("<tr><td colspan=3><div class=title>List of scanned Hosts and Services</div><hr></td></tr>");
		$this->Output('<script language="javascript">');
		$this->Output("function CheckHost(obj)\n");
		$this->Output("{ //window.alert(obj.checked);\n }\n");
		$this->Output("</script>\n");

		$idx = 0;
		foreach ($gHosts as $k => $a) {
			$h = (isset($a['HOSTNAME'])) ? $a['HOSTNAME'] : $k;
			$islisted = $this->CheckHost($h,$k);
			
			$this->Output('<tr>');
			$this->Output("<td class=evenCell align=left><b>$h</b></td>\n");
  			$this->Output("<td class=evenCell>&nbsp;</td>\n");
			$this->Output('<td class=evenCell>');
			 
			if (!$islisted) {
				$this->Output("Add to Host List: <input type=checkbox name='add[]' value='$idx' onclick=\"CheckHost(this)\">&nbsp;"); 
				$this->Output("Check by Ping: <input type=checkbox name='ping[]' value='$idx'>"); 
				$this->Output("<input type=hidden name='address[]' value='$k'>\n");
				$this->Output("<input type=hidden name='hostname[]' value='$h'>\n");
				$somethingToCreate = true;
				$idx++;
			}
			else {
				$this->Output("host already defined");
			}
			$this->Output('</td>');
			$this->Output("</tr>\n");
			
			$this->Output('<tr>');
			$this->Output('<td class=oddCell>Address</td>');
			$this->Output('<td class=cell>&nbsp;</td>');
			$this->Output("<td class=cell>$k</td>");
			$this->Output("</tr>\n");

			$this->Output('<tr>');
			$this->Output('<td class=oddCell valign=top>TCP Services</td>');
			$this->Output('<td class=cell>&nbsp;</td>');
			$this->Output('<td class=cell>');
			$this->Output('<table border=0 width=100%>');
		
		if (isset($a['tcp'])) {
			foreach ($a['tcp'] as $pv => $pn) {
				if ($pn == "") $pn = "unknown";
				$this->Output("<tr><td class=cell>$pv ($pn)</td><td class=cell align=right>");
				if (!$islisted) {
					# display a checkbox if we can associate the port number and the check command:
					$nodesc = true;
					foreach ($tcp_desc as $tk => $td) {
						if ($tk == $pv) {
							$this->Output("Add to Service List: <input type=checkbox name='tcp_${h}[]' value='$pv'>");
							$nodesc = false;
							break;
						}
					}
					if ($nodesc) {
						#echo "Description missing";
						# In this case, we will compute a check_tcp check command !
						$this->Output("Add to Service List: <input type=checkbox name='tcp_${h}[]' value='$pv'>");
					}
				}
				else {
					# Check if the service is already in the conf:
					# Too difficult....almost impossible at 100%
				}
				$this->Output("</td></tr>\n");
			}
		} 
		else {
			$this->Output("&nbsp;(empty)");
		} // isset
		  
			$this->Output("</table>\n");
  			$this->Output('</td>');
			$this->Output("</tr>\n");
			
			$this->Output('<tr>');
			$this->Output('<td class=oddCell valign=top>UDP Services</td>');
			$this->Output('<td class=cell>&nbsp;</td>');
			$this->Output('<td class=cell>');
			$this->Output('<table border=0 width=100%>');
	
		if (isset($a['udp'])) {
			foreach ($a['udp'] as $pv => $pn) {
				if ($pn == "") $pn = "unknown";
				$this->Output("<tr><td class=cell>$pv ($pn)</td><td class=cell align=right>");
				if (!$islisted) {
					# display a checkbox if we can associate the port number and the check command:
					$nodesc = true;
					foreach ($tcp_desc as $tk => $td) {
						if ($tk == $pv) {
							$this->Output("Add to Service List: <input type=checkbox name='udp_${h}[]' value='$pv'>");
							$nodesc = false;
							break;
						}
					}
					if ($nodesc) {
						#echo "Description missing";
						# In this case, we will compute a check_udp check command !
						$this->Output("Add to Service List: <input type=checkbox name='udp_${h}[]' value='$pv'>");
					}
				}
				else {
					# Check if the service is already in the conf:
					# Too difficult....almost impossible at 100%
				}
				$this->Output("</td></tr>\n");
			}
		}
		else {
			$this->Output("&nbsp;(empty)");
		} // isset
			
			$this->Output("</table>\n");
  			$this->Output('</td>');
			$this->Output('</tr>');
		}

		if ($somethingToCreate) {
		
			// Display the list box to get the config filenames:
			$this->Output("<tr><td colspan=3>");
			$this->Output("<table><tr><td class=evenCell>Hosts Configuration Filename: </td><td>");
			$this->Output("<select class=formItem name='host_cfgfile'>");
			try {
				$filelist = $gDB->GetConfigFileList();
				foreach ($filelist as $file) {
					$this->Output("<option   value='${file['filename']}'>${file['filename']}</option>\n");
				}
			}
			catch (Exception $e) {
				$this->Output("Database error: ".$e->getMessage());
			}
			$this->Output("</select>\n");
			$this->Output("</td></tr>\n");

			$this->Output("<tr><td class=evenCell>Services Configuration Filename: </td><td>");
			$this->Output("<select class=formItem name='srv_cfgfile'>");
			foreach ($filelist as $file) {
				$this->Output("<option   value='${file['filename']}'>${file['filename']}</option>\n");
			}
			$this->Output("</select>\n");
			$this->Output("</td></tr></table></td></tr>\n");
		
			$this->Output('<tr><td>&nbsp;</td>');
			$this->Output('<td colspan="2" align="left">');
			$this->Output('<input class=button type="submit" value="Create new Hosts and Services" name="create">');
 			$this->Output('</td>');
			$this->Output("</tr>\n");
		}

	} // if count($gHosts)
		
	$this->Output("</table>\n");
	$this->Output("</form>\n");
}

# -----------------
# nmap run handling:
# -----------------
private function ParseResults()
{
	global $nmap_tcp_result;
	global $nmap_udp_result; 

	if (file_exists($nmap_tcp_result))
		$this->ParseResult($nmap_tcp_result);
	if (file_exists($nmap_udp_result))
		$this->ParseResult($nmap_udp_result);
}

private function ParseResult($tmpfname)
{
	global $gErrorMSG;
	
	if (!($fp = @fopen($tmpfname,"r"))) {
		$gErrorMSG = "Could not open file '$tmpfname'";
		return false;
	}
	$data = @fread($fp,filesize($tmpfname));
	@fclose($fp);
	
	$parser = xml_parser_create();
	xml_set_element_handler($parser,"StartHandler","EndHandler");

	if (!xml_parse($parser,$data,TRUE)) {
		$xmlcode = xml_get_error_code($parser);
		$gErrorMSG = "The XML Parsing failed.<br>";
		$gErrorMSG .= "Error: ".xml_error_string($xmlcode)." at line: ".xml_get_current_line_number($parser).", column: ".xml_get_current_column_number($parser);
		xml_parser_free($parser);
		return false;
	}

	xml_parser_free($parser);

	return true;
}

private function CheckHost($h,$a)
{
	global $gDB;
	
	try {
		$hosts = $gDB->GetObjectOfType("Host");
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return;
	}
	
	foreach ($hosts as $key => $host) {
		if (isset($host['host_name'])) {
			if ($h == $host['host_name'])
				return true;
		}
		if (isset($host['address'])) {
			if ($a == $host['address'])
				return true;
		}
	}

	return false;
}

# -------------------------------------
# Create new hosts and services objects:
# -------------------------------------
private function CreateNewObjects()
{
	global $gDB;
	
	try {
		$this->m_hosts 		= $gDB->GetObjectOfType("Host");
		$this->m_services 	= $gDB->GetObjectOfType("Service");
		$this->m_commands 	= $gDB->GetObjectOfType("Command");
		$this->m_timeperiods 	= $gDB->GetObjectOfType("Timeperiod");
		$this->m_contactgroups	= $gDB->GetObjectOfType("ContactGroup");
	}
	catch (Exception $e) {
		$this->m_report[] = "Internal Error: ".$e->getMessage();
		return;
	}

	# Add hosts:
	for ( $idx = 0 ; $idx < count($_POST['add']) ; $idx++ ) {
		$hidx = $_POST['add'][$idx];
		$h = $_POST['hostname'][$hidx];
		
		// Safety check if the user pressed the Back key and redo the
		// same form again:
		$isNewHost = false;
		if (!$this->CheckHost($h,$_POST['address'][$hidx])) {
			$this->AddNewHost($hidx,$h);
			$isNewHost = true;
		}
		else {
			continue;	// rough !
		}

		# beware: PHP replaces '.' by '_' in field names:
		//$s = preg_replace("/\./","_",$_POST['address'][$hidx]);
		$s = preg_replace("/\./","_",$h);
		//$s = $_POST['add'][$idx];
		
		# Add services:
		if (isset($_POST["tcp_$s"])) {
			for ( $jdx = 0 ; $jdx < count($_POST["tcp_$s"]) ; $jdx++ ) {
				// TODO: check if service not already defined: how ?
				$this->AddNewTCPService($jdx,$h);
			}
		}
		if (isset($_POST["udp_$s"])) {
			for ( $jdx = 0 ; $jdx < count($_POST["udp_$s"]) ; $jdx++ ) {
				// TODO: check if service not already defined: how ?
				$this->AddNewUDPService($jdx,$h);
			}
		}
	}
}

private function AddNewHost($idx,$h)
{
	global $gDB;
	
	# Get a default cfg file if object is new
	$cfgfile = $_POST['host_cfgfile'];

	# host_use_dflt must exist
	if (!$this->CheckHostName($GLOBALS['host_use_dflt'])) {
		$this->m_report[] = "Could not add Host $h: Host Template '".$GLOBALS['host_use_dflt']."' does not exist";
		return;
	}

	/*
	# contact_groups must exist
	if (!$this->CheckContactGroup($GLOBALS['host_contact_groups_dflt'])) {
		$this->m_report[] = "Could not add Host $h: Contact Group '".$GLOBALS['host_contact_groups_dflt']."' does not exist";
		return;
	}

	# check_command_dflt must exist
	if (!$this->CheckCommand($GLOBALS['host_check_command_dflt'])) {
		$this->m_report[] = "Could not add Host $h: Command '".$GLOBALS['host_check_command_dflt']."' does not exist";
		return;
	}

	# notification_period_dflt must exist
	if (!$this->CheckNotificationPeriod($GLOBALS['host_notification_period_dflt'])) {
		$this->m_report[] = "Could not add Host $h: Notification Period '".$GLOBALS['host_notification_period_dflt']."' does not exist";
		return;
	}
	if (!$this->CheckNotificationPeriod($GLOBALS['host_check_period_dflt'])) {
		$this->m_report[] = "Could not add Host $h: Check Period '".$GLOBALS['host_check_period_dflt']."' does not exist";
		return;
	}
	*/

	$host = ObjectFactory::Factory("Host");
	$host->SetContext($cfgfile);

	$host->AddAttr('use',$GLOBALS['host_use_dflt']);
	$host->AddAttr('host_name',$h);
	$host->AddAttr('alias',$h);
	$host->AddAttr('address',$_POST['address'][$idx]);
	/*
	$host->AddAttr('check_command',$GLOBALS['host_check_command_dflt']);
	$host->AddAttr('contact_groups',$GLOBALS['host_contact_groups_dflt']);
	$host->AddAttr('check_period',$GLOBALS['host_check_period_dflt']);
	$host->AddAttr('max_check_attempts',$GLOBALS['host_max_check_attempts_dflt']);
	$host->AddAttr('notification_interval',$GLOBALS['host_notification_interval_dflt']);
	$host->AddAttr('notification_period',$GLOBALS['host_notification_period_dflt']);
	$host->AddAttr('notification_options',$GLOBALS['host_notification_options_dflt']);
	$host->AddAttr('active_checks_enabled',$GLOBALS['host_active_checks_enabled']);
	$host->AddAttr('notifications_enabled',$GLOBALS['host_notifications_enabled']); 
	*/

	# insert the host in the DB
	try {
		$objid = $gDB->GetMaxObjID();
		$host->AddAttr("__objid",$objid);
		$gDB->Store($host,0,array("# added by EZNag/Nmap\n"),$objid);
		$this->m_report[] = "Host $h added";
	}
	catch (Exception $e) {
		$this->m_report[] = "Internal Error: ".$e->getMessage();
		return;
	}

	# Add an entry for the PING service ?
	if (isset($_POST['ping'][$idx]) && $_POST['ping'][$idx]) {
		$this->AddPingService($idx,$h);
	}
}

function AddNewTCPService($jdx,$h)
{
	global $tcp_desc;

	# beware: PHP replaces '.' by '_' in field names:
	$s = preg_replace("/\./","_",$h);
	//$s = $h;
	
	$port = $_POST["tcp_$s"][$jdx];
	if (!isset($tcp_desc[$port])) {
		$cmd = "check_tcp!$port";
		$desc = "$port/tcp";
	}
	else {
		$cmd = $tcp_desc[$port]['cmd'];
		$desc = $tcp_desc[$port]['desc'];
	}

	$this->_AddService($h,$desc,$cmd);
}

function AddNewUDPService($jdx,$h)
{
	global $udp_desc;

	# beware: PHP replaces '.' by '_' in field names:
	$s = preg_replace("/\./","_",$h);
	//$s = $h;
	
	$port = $_POST["udp_$s"][$jdx];
	if (!isset($udp_desc[$port])) {
		$cmd = "check_udp!$port";
		$desc = "$port/udp";
	}
	else {
		$cmd = $udp_desc[$port]['cmd'];
		$desc = $udp_desc[$port]['desc'];
	}

	$this->_AddService($h,$desc,$cmd);
}

function AddPingService($idx,$h)
{
	$this->_AddService($h,"PING","check_ping!100.0,20%!500.0,60%");
}

function _AddService($h,$srv_desc,$check_cmd)
{
	global $gDB;
	
	//echo "_AddService($h,$srv_desc,$check_cmd)";

	$cfgfile = $_POST['srv_cfgfile'];

	# service_use_dflt must exist
	if (!$this->CheckServiceName($GLOBALS['service_use_dflt'])) {
		$this->m_report[] = "Could not add Service $srv_desc: Service Template '".$GLOBALS['service_use_dflt']."' does not exist";
		return;
	}

	/*
	# contact_groups must exist
	if (!$this->CheckContactGroup($GLOBALS['service_contact_groups_dflt'])) {
		$this->m_report[] = "Could not add Service $srv_desc: Contact Group '".$GLOBALS['service_contact_groups_dflt']."' does not exist";
		return;
	}

	# check_period_dflt must exist
	if (!$this->CheckNotificationPeriod($GLOBALS['service_check_period_dflt'])) {
		$this->m_report[] = "Could not add Service $srv_desc: Notification Period '".$GLOBALS['service_check_period_dflt']."' does not exist";
		return;
	}

	# notification_period_dflt must exist
	if (!$this->CheckNotificationPeriod($GLOBALS['service_notification_period_dflt'])) {
		$this->m_report[] = "Could not add Service $srv_desc: Notification Period '".$GLOBALS['service_notification_period_dflt']."' does not exist";
		return;
	}
	*/

	$srv = ObjectFactory::Factory("Service");
	$srv->SetContext($cfgfile);

	$srv->AddAttr('use',$GLOBALS["service_use_dflt"]);
	$srv->AddAttr('host_name',$h);
	$srv->AddAttr('service_description',$srv_desc);
	/*
	$srv->AddAttr('is_volatile',$GLOBALS['service_is_volatile_dflt']);
	$srv->AddAttr('check_period',$GLOBALS['service_check_period_dflt']);
	$srv->AddAttr('max_check_attempts',$GLOBALS['service_max_check_attempts_dflt']);
	$srv->AddAttr('normal_check_interval',$GLOBALS['service_normal_check_interval_dflt']);
	$srv->AddAttr('retry_check_interval',$GLOBALS['service_retry_check_interval_dflt']);
	$srv->AddAttr('contact_groups',$GLOBALS['service_contact_groups_dflt']);
	$srv->AddAttr('notification_interval',$GLOBALS['service_notification_interval_dflt']);
	$srv->AddAttr('notification_period',$GLOBALS['service_notification_period_dflt']);
	$srv->AddAttr('notification_options',$GLOBALS['service_notification_options_dflt']);
	$srv->AddAttr('notifications_enabled',$GLOBALS['service_notifications_enabled']);
	$srv->AddAttr('passive_checks_enabled',$GLOBALS['service_passive_checks_enabled']); 
	$srv->AddAttr('active_checks_enabled',$GLOBALS['service_active_checks_enabled']); 
	*/
	$srv->AddAttr('check_command',$check_cmd);
	
	# insert the service in the DB
	try {
		$objid = $gDB->GetMaxObjID();
		$srv->AddAttr("__objid",$objid);
		$gDB->Store($srv,0,array("# added by EZNag/Nmap\n"),$objid);
		$this->m_report[] = "Service $srv_desc for host $h added";
	}
	catch (Exception $e) {
		$this->m_report[] = "Internal Error: ".$e->getMessage();
		return;
	}
}

function CheckHostName($host)
{
	$found = 0;
	if (!is_array($this->m_hosts)) return 0;
	
	foreach ($this->m_hosts as $h) {
		if ($host == $h['name']) {
			$found = 1;
			break;
		}
	}

	return $found;
}

function CheckServiceName($service)
{
	$found = 0;
	if (!is_array($this->m_services)) return 0;
	
	foreach ($this->m_services as $s) {
		if ($service == $s['name']) {
			$found = 1;
			break;
		}
	}

	return $found;
}

function CheckNotificationPeriod($period)
{
	$found = 0;
	if (!is_array($this->m_timeperiods)) return 0;
	
	foreach ($this->m_timeperiods as $t) {
		if ($period == $t['timeperiod_name']) {
			$found = 1;
			break;
		}
	}

	return $found;
}

function CheckContactGroup($group)
{
	$found = 0;
	if (!is_array($this->m_contactgroups)) return 0;
	
	foreach ($this->m_contactgroups as $cg) {
		if ($group == $cg['contactgroup_name']) {
			$found = 1;
			break;
		}
	}

	return $found;
}

function CheckCommand($cmd)
{
	$found = 0;
	if (!is_array($this->m_commands)) return 0;
	
	foreach ($this->m_commands as $co) {
		if ($cmd == $co['command_name']) {
			$found = 1;
			break;
		}
	}

	return $found;
}

private $m_msg;
private $m_report = array();
private $m_hosts = array();
private $m_services = array();
private $m_commands = array();
private $m_contactgroups = array();
private $m_timeperiods = array();

};

function StartHandler($parser,$tag,$attribs)
{
	global $gHosts,$insideHost;
	global $curaddr,$curproto,$curport,$curname;

	if ($tag == "HOST") $insideHost = true;
	if ($tag == "ADDRESS" && $insideHost) {
		if (isset($attribs['ADDRTYPE']) && 
		    $attribs['ADDRTYPE'] == "ipv4") {
			$curaddr = $attribs['ADDR'];
		}
	}
	if ($tag == "HOSTNAME" && $insideHost && $curaddr) {
		if (isset($attribs['NAME']))
			$gHosts[$curaddr]['HOSTNAME'] = $attribs['NAME'];
	}
	if ($tag == "PORT" && $insideHost) {
		if (isset($attribs['PROTOCOL']))
			$curproto = $attribs['PROTOCOL'];
		if (isset($attribs['PORTID']))
			$curport = $attribs['PORTID'];
	}
	if ($tag == "STATE" && $insideHost) {
		if (isset($attribs['STATE']))
			if (strstr("opne",$attribs['STATE'])) $curport = "";
	}
	if ($tag == "SERVICE" && $insideHost) {
		if (isset($attribs['NAME']))
			$curname = $attribs['NAME'];
	}
}

function EndHandler($parser,$tag)
{
	global $gHosts,$insideHost;
	global $curaddr,$curproto,$curport,$curname;

	if ($tag == "HOST") {
		$insideHost = false;
		$curaddr = "";
	}
	if ($tag == "PORT" && $insideHost && $curaddr && 
	    $curproto && $curport) {
		$gHosts[$curaddr][$curproto][$curport] = $curname;
		$curport = $curproto = $curname = "";
	}
}

?>
