<?php
function onlydigit($parm)
{
	return preg_replace('/[^0-9]/','',$parm);
}

function onlyletter($parm)
{
	return preg_replace('/[^a-zA-Z]/','',$parm);
}

function filename($parm)
{
	return preg_replace('/[^-a-zA-Z0-9.:_\/]/','',$parm);
}

function nagiosstring($parm)
{
	return preg_replace('/[^-a-zA-Z0-9._ ]/','',$parm);
}

function nmapstring($parm)
{
	return preg_replace('/[^-a-zA-Z0-9._,\/]/','',$parm);
}

function command($parm)
{
	return preg_replace('/[^-a-zA-Z0-9.:_\/ ]/','',$parm);
}

function boolean($parm)
{
	return preg_replace('/[^01]/','',$parm);
}

function SanitizeParms(&$vars, $signatures, $redir_url = NULL)
{
	global $gErrorMSG;
	
	$tmp = array();
	
	foreach ($signatures as $name => $sig) {
		if (!isset($vars[$name]) &&
		    isset($sig['req']) && $sig['req']) {
			//if ($redir_url) {
				//header("Location: $redir_url");
			//}
			//else {
				$gErrorMSG = "Parameter '$name' not present";
			//}
			return false;
		}
	
		if (!isset($vars[$name])) $vars[$name] = "";
			
		$tmp[$name] = $vars[$name];
		if (isset($sig['type'])) {
			settype($tmp[$name],$sig['type']);
		}
		
		if (isset($sig['filter'])) {
			# Test added with v0.11
			if ($sig['filter'] != 'addslashes' || !get_magic_quotes_gpc())
				$tmp[$name] = $sig['filter']($tmp[$name]);
		}
	}
	
	$vars = $tmp;
	
	return true;
}

function SanitizeConfParms(&$vars, &$signatures)
{
	$ok = true;
	
	$tmp = array();
	
	foreach ($signatures as $name => $sig) {
		if (!isset($vars[$name]) &&
		    isset($sig['req']) && $sig['req']) {
			$sig['error'] = "Parameter must not be empty";
			$ok = false;
			continue;
		}
	
		if (!isset($vars[$name])) $vars[$name] = "";
			
		$tmp[$name] = $vars[$name];
		if (isset($sig['type'])) {
			settype($tmp[$name],$sig['type']);
		}
		
		if (isset($sig['filter'])) {
			$tmp[$name] = $sig['filter']($tmp[$name]);
		}
	}
	
	$vars = $tmp;
	
	return $ok;
}
?>
