<?php
include_once "actionbase.inc.php";
include_once "displayobject.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
		'__objtype' => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'addslashes'
			 	),
		'__objid'	  => array (
				'req' => true, 
				'type' => 'string',
				'filter' => 'onlydigit'
				),
	);

public function Run()
{
	global $gDB;
	global $gSMG;
	
	$objid   = $_REQUEST['__objid'];
	$objtype = $_REQUEST['__objtype'];

	// objtype can be Contact or ContactGroup
	try {
		$ze_obj = $gDB->BuildObject($objtype,$objid);
		$gDB->BuildObjectInherited($ze_obj);
	}
	catch (Exception $e) {
		$gMSG = "Internal Error: ".$e->getMessage();
		return;
	}

	// Get the list of all ContactGroup:
	try {
		$contactgrouplist = $gDB->GetObjectOfType("ContactGroup");
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return;
	}
	
	$this->m_build_contactlist = array();
	$this->m_build_objects = array();

	if ($objtype == "Contact") {
		// Get the Contact Name
	
		// Build the list of ContactGroup where this name belong

		// Build the list of objects concerned
	}

	$contactgroup_objects = array ("Host","Service","ServiceEscalation","HostEscalation");

	if ($objtype == "ContactGroup") {
		$attr = $ze_obj->GetAttr();
		assert(isset($attr['contactgroup_name']));
		$objname = $attr['contactgroup_name'];
		$this->AddContactGroup($ze_obj);

		// Get the list of all the ContactGroups and recursively adds
		// the contactgroup name where the given contactgroup belongs
		// directly or as a contactgroup_member.
		$this->CheckContactGroup($attr['contactgroup_name']);

		// Build the list of objects concerned
		foreach ($contactgroup_objects as $contact_objtype) {
			$this->CheckObject($contact_objtype,"contact_groups");
		}
	}

	print_r($this->m_build_contactlist); echo "<br>";
	print_r($this->m_build_objects);

	$this->Output("<div class=title>List of watched Objects for $objtype '$objname' </div><hr>");
	$this->Output("<table><tr class=rowhdr><th>Host</th><th>Service</th><th>HostEscalation</th><th>ServiceEscalation</th></tr><tr class=evenCell>\n");
	foreach ($contactgroup_objects as $objtype) {
		$this->Output("<td>");
		foreach ($this->m_build_objects[$objtype] as $objname) {
			$this->Output("$objname<br>");
		}
		$this->Output("</td>");
	}
	$this->Output("</tr></table>\n");
}

private function AddContactGroup($obj)
{
	$attrlist = $obj->GetAttr();
	$contactname = $obj->IsTemplate() ? $attrlist['name'] : $attrlist['contactgroup_name'];

	if (!in_array($contactname,$this->m_build_contactlist)) array_push($this->m_build_contactlist,$contactname);
}

private function CheckContactGroup($contactgroup_name)
{
	global $gDB;
	global $gErrorMSG;

	// Get the list of all ContactGroup:
	try {
		$contactgrouplist = $gDB->GetObjectOfType("ContactGroup");
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return false;
	}
	
	// Scan the whole list of contact group while at least one contact group has been
	// added to the list 
	$new_added = false;
	do {
		foreach ($contactgrouplist as $contactgroup) {
			try {
				$obj = $gDB->BuildObject("ContactGroup",$contactgroup['__objid']);
				$gDB->BuildObjectInherited($obj);
			}
			catch (Exception $e) {
				$gMSG = "Internal Error: ".$e->getMessage();
				return false; 
			}

			// Add this contact group in the list if one of its members is $contactgroup_name:
			$attr = $obj->GetAttr();
			$contactgroup_members = explode(",",$attr['contactgroup_members']);
			foreach ($contactgroup_members as $member) {
				if ($member == $contactgroup_name) {
					if (!in_array($contactgroup['contactgroup_name'],$this->m_build_contactlist)) 
						array_push($this->m_build_contactlist,$contactgroup['contactgroup_name']);
					$new_added = true;
					break;
				}
				// ...or if one of its member already belongs to the list:
				if (in_array($member,$this->m_build_contactlist)) {
					if (!in_array($member,$this->m_build_contactlist)) 
						array_push($this->m_build_contactlist,$member);
					$new_added = true;
					break;
				}
			}

			// Also adds the contact group if it depends of a template that has been marked:
			if (isset($attr['use']) && in_array($attr['use'],$this->m_build_contactlist)) {
				if (!in_array($attr['use'],$this->m_build_contactlist))
					array_push($this->m_build_contactlist,$attr['use']);
				$new_added = true;
			}
		}
	} while ($new_added);

	return true;
}

private function CheckObject($objtype,$attrname)
{
	global $gDB;
	global $gErrorMSG;

	try {
		$objlist = $gDB->GetObjectOfType($objtype);
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return;
	}

	// Get the index name:
	$obj = ObjectFactory::Factory($objtype);
	$indexes = $obj->GetIndex();
	assert(is_array($indexes));

	foreach ($objlist as $obj) {
		$objid = $obj['__objid'];
		$curobj = $gDB->BuildObject($objtype,$objid);
		$gDB->BuildObjectInherited($curobj);
		$attr = $curobj->GetAttr();

		$attr_value = $attr[$attrname];
		$contacts = explode(",",$attr_value);
		echo "attrname=$attrname,attr_value=$attr_value<br>";
		print_r($contacts); echo "<br>";
		foreach ($contacts as $contact) {
			if (in_array($contact,$this->m_build_contactlist)) {
				// Ugly test:
				if ($obj['name']) {
					$objname = $obj['name']." (template)";
				}
				else {
					foreach ($indexes as $index) {
						if ($objname) $objname .= "/";
						$objname .= $obj[$index];
					}
				}
				if (!isset($this->m_build_objects[$objtype])) $this->m_build_objects[$objtype] = array();
				array_push($this->m_build_objects[$objtype],$objname);
			}
		}
	}
}

private $m_build_contactlist = array();
private $m_build_objects = array();

};
?>
