<?php
include_once "actionbase.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
		'__nomenu' => array (
				'req' => false, 
                                'type' => 'integer',
			 	),
                '__objid'  => array (
                                'req' => true,
                                'type' => 'string',
                                'filter' => 'onlydigit'
                                ),
	);

public function Run()
{
	global $gDB;
	global $gLogger;
	
	$objtype = "Command";
        $objid   = $_REQUEST['__objid'];

        try {
                $ze_obj = $gDB->BuildObject($objtype,$objid);
                $gDB->BuildObjectInherited($ze_obj);
        }
        catch (Exception $e) {
                $gMSG = "Internal Error: ".$e->getMessage();
                return;
        }

	// Get the plugin name:
        $attrlist = $ze_obj->GetAttr();
	$command = $attrlist['command_line'];
	$parts = explode(' ',$command);
	$names = explode('/',$parts[0]);
	$plugin_name = $names[count($names)-1];

	// Substitute known variables:
	if (preg_match('/(\$[[:alnum:]]+\$)/',$command,$matches)) {
		for ( $idx = 1 ; $idx < count($matches) ; $idx++ ) {
			$varname = $matches[$idx];
			try {
				$value = $gDB->getMainParm($varname);
			}
			catch (Exception $e) {
				//$gMSG = "Variable '$varname' not defined in Nagios Configuration Files";
				//return;
			}
			$gLogger->Debug("varname=$varname, value=$value");
			$command = str_replace($varname,$value,$command);
		}
	}

	// From v1.0: just call with the --help parameter
	//$command = "$command --help";
	$parts = explode(' ',$command);
	$command = $parts[0]." --help";

        global $gErrorMSG;
        global $gMSG;

        $lastline = @exec($command,$output,$status);
        if ($status) {
                $gErrorMSG = "Error while executing command (status=$status):<br>'$command'";
        }
        else {
                //$gMSG = "Here is the syntax for plugin <b>$plugin_name</b> !";
        }

	// Display the help syntax:
        $this->DisplayCommandOutput($output);
}

};
?>
