<?php
include_once "actionbase.inc.php";

class Action extends ActionBase
{
public $m_sigs = array (
		'__nomenu' => array (
				'req' => false, 
                                'type' => 'integer',
			 	),
	);

public function Run()
{
	global $gDB;
	
	$objtype = "Command";

	try {
		$objlist = $gDB->GetObjectOfType($objtype);
	}
	catch (Exception $e) {
		$gErrorMSG = "Internal Error: ".$e->getMessage();
		return;
	}

       	// Get the index name:
        $obj = ObjectFactory::Factory($objtype);
        $indexes = $obj->GetIndex();

        assert(is_array($indexes));
        if (count($indexes) == 0) 
                die("Internal Error: no INDEX found for Object Type '$objtype'");
	
	// Display the header:
	$this->Output("<div class=title>Command List</div><hr>");
	
	if (!is_array($objlist) || count($objlist) == 0) {
		$this->Output("<p class=evenCell>(empty)</p>");
		return;
	}
	
	// We display non-template Commands only:
	$this->Output("<table>\n");
		
	$this->Output("<tr class=rowhdr><th>Syntax</th><th colspan=".count($indexes).">Name</th><th>Command Line</th></tr>");
	
	$objnu = 0;
	
	foreach ($objlist as $obj) {
		$objid = $obj['__objid'];
		$curobj = $gDB->BuildObject($objtype,$objid);
		if ($curobj->IsTemplate()) continue;

		if (($objnu % 2) == 0)		
			$cellclass = "evenCell";
		else 
			$cellclass = "oddCell";
		$objnu++;
			
		$this->Output("<tr class=$cellclass>");			
		$this->Output("<td><a href=\"index.php?action=showsyntax&__objid=$objid&__nomenu=1\">Show</a></td>");
		foreach ($indexes as $index) {
			$this->Output("<td>");
			$this->Output($obj[$index]);
			$this->Output("</td>");
		}
		$this->Output("<td>".$obj['command_line']."</td>");
		$this->Output("</tr>\n");
	}
		
	$this->Output("</table>\n");
}

};
?>
