<?php
include_once "actionbase.inc.php";
include_once "../conf/log.class.php";
include_once "../conf/config.class.php";
include_once "../conf/database.class.php";

class Action extends ActionBase
{
public $m_sigs = array ();

public function Init()
{
}

public function Run()
{
	global $gDB;
	global $gErrorMSG;
	global $gMSG;
	global $gDBFile;
	global $gMustRebuildURL;
	global $gBackupDir;
	
	$conf = new Config($gDB);
	
	$mainfile = $conf->GetNagiosMainFileName();
	if ($mainfile == "") {
		$gErrorMSG = "Unable to find the Main Configuration Filename. Please, update 'config.inc.php' file";
		return;
	}

	// Compute the backup directory:
	$curdate = strftime("%Y-%m-%d,%T");
	$bkpdir = $gBackupDir."/bkp-$curdate";
	if (!is_dir($bkpdir)) {
		if (!@mkdir($bkpdir)) {
			$gErrorMSG = "Unable to create the Backup Directory $bkpdir.";
			return;
		}
	}
	else if (!is_writeable($bkpdir)) {
		$gErrorMSG = "The Backup Directory $bkpdir is not writeable.";
		return;
	}
	
	try {
		$conf->WriteConf($gDBFile,$bkpdir);
	}
	catch (Exception $e) {
		$gErrorMSG = $e->getMessage();
		
		ob_start();
		$action = "writeconf";
		$output = implode("",file("$gMustRebuildURL"));
		$output = eval("?>$output"); 
		$output = ob_get_contents();
		ob_end_clean();
		$this->Output($output);
		return;
	}
	
	// From v1.0: adds a longer message
	//$gMSG = "Configuration saved.";
	$gMSG = "Configuration saved.<br>Old configuration files have been saved under '".realpath($bkpdir)."'";
	
	ob_start();
	$action = "Restart";
	$output = implode("",file("$gMustRebuildURL"));
	$output = eval("?>$output"); 
	$output = ob_get_contents();
	ob_end_clean();
	$this->Output($output);
}

};
