#!/bin/bash
# ============================================================================
# 
# Installation and configuration of additional plugins
#
# ----------------------------------------------------------------------------
#
# TODO: 
#
# ============================================================================
#
. ./utils.sh

# ----------------
# Global Variables:
# ----------------
. ./params.sh

CheckRoot

if [ "$UPDATE" = "y" ]; then
	exit 0
fi

if [ ! -e "$TMPDIR/plugins" ]; then
	mkdir "$TMPDIR/plugins"
fi

# ------------------
# check_file
# ------------------
PLUGIN=check_file-1.1
cp distrib/plugins/$PLUGIN.tar.gz "$TMPDIR/plugins"
pushd "$TMPDIR/plugins" >/dev/null
gunzip $PLUGIN.tar.gz
tar xvf $PLUGIN.tar >> "$OUTPUTFILE" 2>&1
cd $PLUGIN
gcc check_file.c -o check_file >> "$OUTPUTFILE" 2>&1
cp check_file $DSTDIR/libexec
popd >/dev/null

# -----------------------------
# check_oracle_tablespace
# -----------------------------
PLUGIN=check_oracle_tablespace_1.7
cp distrib/plugins/$PLUGIN.tar.gz "$TMPDIR/plugins"
pushd "$TMPDIR/plugins" >/dev/null
tar xvfz $PLUGIN.tar.gz >> "$OUTPUTFILE" 2>&1
cd $PLUGIN
cp check_oracle_tablespace.sh $DSTDIR/libexec
popd >/dev/null

# -----------------------------
# check_email_delivery
# -----------------------------
PLUGIN=check_email_delivery-0.6.4
cp distrib/plugins/$PLUGIN.tar.gz "$TMPDIR/plugins"
pushd "$TMPDIR/plugins" >/dev/null
tar xvfz $PLUGIN.tar.gz >> "$OUTPUTFILE" 2>&1
cd $PLUGIN
cp check_* $DSTDIR/libexec
popd >/dev/null

# -----------------------------
# check_file_size
# -----------------------------
PLUGIN=check_file_size.sh
cp distrib/plugins/$PLUGIN $DSTDIR/libexec

# -----------------------------
# check_smart_attributes
# -----------------------------
PLUGIN=check_smart_attributes
cp distrib/plugins/$PLUGIN $DSTDIR/libexec

# -----------------------------
# check_lm_sensors
# -----------------------------
perl -MCPAN -e 'install Nagios::Plugin'
perl -MCPAN -e 'install Nagios::Plugin::Threshold'
perl -MCPAN -e 'install version' 
PLUGIN=check_lm_sensors-3.1.1
cp distrib/plugins/$PLUGIN.tar.gz "$TMPDIR/plugins"
pushd "$TMPDIR/plugins" >/dev/null
tar xvfz $PLUGIN.tar.gz >> "$OUTPUTFILE" 2>&1
cd $PLUGIN
perl Makefile.PL INSTALLSITESCRIPT=$DSTDIR/libexec >> "$OUTPUTFILE" 2>&1
make >> "$OUTPUTFILE" 2>&1
sed -i -e 's/#!perl/#!\/usr\/bin\/perl/' check_lm_sensors
cp check_lm_sensors $DSTDIR/libexec
popd >/dev/null

# -----------------------------
# check_sensors
# -----------------------------
PLUGIN=check_sensors
cp distrib/plugins/$PLUGIN $DSTDIR/libexec

# ---------------------------------------------
# Global rights (overwrite those in install.sh):
# ---------------------------------------------
chown $NAGIOSUSR:$APACHEGRP $DSTDIR/libexec/*
chmod 550 $DSTDIR/libexec/*

exit 0

# EOF
