#!/bin/bash
# ============================================================================
# 
# Utility Functions
#
# ----------------------------------------------------------------------------
#
# TODO:
#
# ============================================================================
#

COLNORM="[0;0m"
COLINFO="[0;33m"
COLINF2="[0;36m"
COLWARN="[0;35m"
COLERRO="[0;31m"
COLQUES="[0;32m"
COLSTEP="[1;36m"

Error () {
	echo ${COLERRO}$1${COLNORM}
	exit 1
}

AskYesNo () {
	REP=
	while [ "$REP" != "y" -a "$REP" != "n" ]; do
		read -p "${COLQUES}$1 [y/n] ${COLNORM}" REP
	done
}

CheckRoot () {
	# This script must be executed by 'root':
	if [ `id -u` -ne 0 ]; then
		Error "This script must be executed by 'root'"
	fi
}

Info () {
	echo "${COLINFO}$1${COLNORM}" 
}

#Info "Info message test"
#AskYesNo "Question test"
#Error "Error message test"

# EOF
