#!/usr/bin/perl -w
#$Revision: 1.4 $
#$Author: trig_monkeypr0n $
# Nagios is a registered trademark of Ethan Galstad


############################################################################
# This file is only provided as an example, no work has been done          #
# to make it compatible with anything and there is no documentation on it. #
############################################################################


use strict;
use Data::Dumper; $Data::Dumper::Deepcopy = 1; $Data::Dumper::Indent = 1;
sub d { warn Data::Dumper->Dump( [$_[0]], [$_[1]] ); }
use Carp;
use Date::Manip;
use Mail::Mailer;
use IO::Socket::UNIX;
use POSIX qw(strftime);

#####CHANGE THE BELOW OPTIONS########
$ENV{MAILADDRESS} = 'your_admin_email@domain.tld';
my $from = "your_admin_email\@domain.tld";
my $smtp_server = "smtp.yourdomain.tld";


sub serv_not {
	my $a = shift;
	my ($not_type, 
		$hostname, 
		$serv_desc, 
		$serv_state, 
		$info, 
		$last_change,
		$addr ) = @_;
	my $sock = IO::Socket::UNIX->new(
		Type => SOCK_STREAM,
    	Peer => '/usr/local/nagios/var/rw/popups.sock',
	) or croak "socket: $!\n";

	#my $time = strftime(localtime $last_change);
	my $time = time - $last_change;
	if( $time > 180 ) {
		$time = sprintf '%d:%02d', int($time / 60), int($time % 60);
	} else {
		$time = $time .'s';
	}
	my %ss = (
		CRITICAL	=> 'CRIT',
		WARNING		=> 'WARN',
		UNKNOWN		=> 'UNK',
	);
	my $state_abbr = $ss{$serv_state} || $serv_state;
	my $body;
	if( $not_type eq 'PROBLEM' ){
		$body = "$state_abbr ($time)"
	}elsif( $not_type eq "RECOVERY" ) {
		$body = "$state_abbr ($time)"
	}else{
		$body = "ACK ($state_abbr $time)";
	}
	$body .= " $hostname: $serv_desc: $info";

	my $m = Mail::Mailer->new(
		'smtp',
		Server => "$smtp_server",
		Debug => 1
	);

	$m->open( {
		To		=>	$addr,
		From 	=>	$from,
	} ) or croak "m->open: $!\n";
	print $m $body;
	$m->close;
	#I know this is a really awful way to do this, but we 
	#wanted to make sure the popups only get sent once per alert. 
	#So, having it send the popup on my number worked out o.k.
	if( $addr eq "number_to_send_popup\@domain.tld" ){
		print $sock->getline;
		$sock->print($body."\n");
	}
	
}

sub host_not {
	my $a = shift;
	my ($not_type,
		$hostname, 
		$state,
		$info,
		$last_change,
		$addr ) = @_;
	my $sock = IO::Socket::UNIX->new(
		Type => SOCK_STREAM,
    	Peer => '/usr/local/nagios/var/rw/popups.sock',
	) or croak "socket: $!\n";
	#my $time = strftime(localtime $last_change);
	my $time = time - $last_change;
	if( $time > 180 ) {
		$time = sprintf '%d:%02d', int($time / 60), int($time % 60);
	} else {
		$time = $time .'s';
	}
	my %ss = (
		UP			=> 'UP',
		DOWN		=> 'DOWN',
		UNREACHABLE	=> 'UNRE',
	);
	my $state_abbr = $ss{$state} || $state;
	my $body;
	if( $not_type eq 'PROBLEM' ){
		$body = "$state_abbr ($time)"
	}elsif( $not_type eq "RECOVERY" ) {
		$body = "$state_abbr ($time)"
	}else{
		$body = "ACK ($state_abbr $time)";
	}
	$body .= " $hostname: $info";

	my $m = Mail::Mailer->new(
		'smtp',
		Server => "$smtp_server",
		Debug => 1
	);

	$m->open( {
		To		=>	$addr,
		From 	=>	$from,
	} ) or croak "m->open: $!\n";
	print $m $body;
	$m->close;
	#I know this is a really awful way to do this, but we 
	#wanted to make sure the popups only get sent once per alert. 
	#So, having it send the popup on my number worked out o.k.
	if( $addr eq "number_to_send_popup\@domain.tld" ){
		print $sock->getline;
		$sock->print($body."\n");
	}
}

if( $ARGV[0] =~ /service/i ){ 
	serv_not( @ARGV );
}elsif( $ARGV[0] eq "host_page" ){
	host_not( @ARGV );
}
